; This file is part of PALESTRA
;
; PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
; un TSR para traducir al castellano la aventura grafica/conversacional
; Les Manley in: Search for the King v2.0
;
; PALESTRA is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 2 of the License, or
; (at your option) any later version.
;
; PALESTRA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
;
; why PALESTRA?
; $ grep les /usr/share/dict/spanish |grep tra
; palestra

; ****************************************
; *                                      *
; *   D A T O S    R E S I D E N T E S   *
; *                                      *
; ****************************************

oldint9 dw 0,0      ;espacio para segment:offset INT_9 sistema
;ultima_tecla_pulsada    db 0

;;<para fixes> (4INTS.ASM:fix_command_bugs proc near)
str_room1 db "Elefantes",0
str_room2 db "Habitaci/n",0
str_cmd1 db "drop shovel",0
str_cmd1_fixed db "leave shovel",0
;;</para fixes>

; <EMS>
; en cada modificacion de desc61_ems/subcadena61_ems, asi que hay que cambiar los valores que hay aqui abajo, segun el nuevo EMSDATA.BIN, hasta </EMS>
ems_seg dw 0e000h    ; fallback, default: e000 (TODO! revisar que 9TSR.ASM lo este haciendo bien, y no dependamos de este valor)
_desc61_ems_array_cx equ 613d
_subcadena61_ems_array_cx equ 25d
; EMSDATA.BIN
_desc61_ems_en_array_offset equ 0619fh ; (segment e000)    ; donde empieza _desc61_ems_en_array_offset en EMSDATA.BIN
_desc61_ems_es_array_offset equ 0d4f8h ; (segment e000)    ; donde empieza _desc61_ems_es_array_offset en EMSDATA.BIN
_subcadena61_ems_en_array_offset equ 0db7ah ; (segment e000)    ; donde empieza _subcadena61_ems_en_array_offset en EMSDATA.BIN
_subcadena61_ems_es_array_offset equ 0e12fh ; (segment e000)    ; donde empieza _subcadena61_ems_es_array_offset en EMSDATA.BIN
_ems_size equ 57697d ; wc -c EMSDATA.BIN
; </EMS>

; <UMB>
umb_seg dw 0,0  ; poner algun valor mas o menos seguro como default?
_umb_paras equ (_umb_size+15d)/16d    ;parrafos UMB necesarios
_desc60_umb_array_cx equ 580d
; UMBDATA.BIN
_desc60_umb_en_array_offset equ 0741ah ; (segment e000)    ; donde empieza _desc60_umb_en_array_offset en UMBDATA.BIN
_desc60_umb_es_array_offset equ 0f36fh ; (segment e000)    ; donde empieza _desc60_umb_es_array_offset en UMBDATA.BIN
_umb_size equ 63479d ; wc -c UMBDATA.BIN
; </UMB>

comando_en db 38 DUP(0) ; comando traducido por el parser. (max_longitud_comando_introducido == 38)
verbo_es_cx dw ?        ; longitud verbo introducido por usuario
verbo_en_cx dw ?        ; longitud verbo_en (verbo traducido por parser)
nombre_es_cx dw ?       ; longitud nombre introducido por usuario
nombre_en_cx dw ?       ; longitud nombre_en (nombre traducido por parser)
;;; falta nombre2cx!!!!
nombre2_es_cx dw ?       ; longitud nombre2 introducido por usuario
nombre2_en_cx dw ?       ; longitud nombre2_en (nombre2 traducido por parser)
prepo_es_cx dw ?        ; longitud preposicion introducida por usuario
prepo_en_cx dw ?        ; longitud prepo_en (preposicion traducida por parser)
di_comando_introducido dw ?     ; indice comando introducido, por donde vamos en todo momento en el parser
di_comando_en dw ?      ; indice comando traducido a ingles, por donde vamos en todo momento en el parser

ultimo_nombre_bx dw ?  ; indice a ultimo nombre introducido
ultimo_nombre2_bx dw ?  ; indice a ultimo nombre2 introducido
ultimo_verbo_bx dw ?    ; indice a ultimo verbo introducido

;;INT_62 mantenia estos valores actualizados.
;;strcpy_plus: primero intenta usar ultimo_loquesea_bx (no es cadena, es un indice), mantenido por parser (y strcmp_plus), en principio mas fiable
;;si ultimo_loquesea_bx == -1, es que ni parser ni strcmp_plus pudieron matchear ultimo_loquesea_introducido con diccionario TSR
;;entonces strcpy_plus, como fallback, usa estas tres variables
;ULTIMO_NOMBRE_EN_INTRODUCIDO db 38 DUP(0)    ; quizas 38 bytes son demasiados y se podria reajustar
;ULTIMO_NOMBRE2_EN_INTRODUCIDO db 38 DUP(0)    ; quizas 38 bytes son demasiados y se podria reajustar
;ULTIMO_VERBO_EN_INTRODUCIDO db 38 DUP(0)    ; quizas 38 bytes son demasiados y se podria reajustar

safemsg db "No puedes hacer eso.",0     ;para cuando %n==" " y/o %v==" "

;; <PREPOSICIONES Y LOCUCIONES PREPOSITIVAS (a falta de un nombre mejor) EN CASTELLANO>
prepo_es0 db "con",0
prepo_es1 db "por",0    ;BUG!! "lower Helmut in drain" lo traduce como "lower Helmut", se come "in drain"
;el problema es que traducimos "por" como "about", para todos los casos. peeeero hay algun edge case. Funciona para "preguntar <nombre> por", pero "bajar <nombre> por" lo traduciria como "lower <nombre> about", cuando lo correcto seria traducirlo por "lower <nombre> in". TODO! buscar una solucion, quizas podriamos tener en cuenta el verbo para estos edge cases, es decir, si se matchea "por", tener en cuenta dos posibilidades:
;                                             si el verbo es "lower" -> traducir prepo como "in"
;                                             si el verbo es "ask" -> traducir prepo como "about"
;es decir:
;                                             si ultimo_verbo_en == "lower" -> ultima_prepo_en = "in"
;                                             si ultimo_verbo_en == "ask" -> ultima_prepo_en = "about"
;TODO! darle una vuelta a esto.

prepo_es2 db "sobre",0
prepo_es3 db "acerca de",0
prepo_es4 db "al",0
;prepo_es5 db "a la",0
prepo_es5 db "a",0
prepo_es6 db "encima de",0
prepo_es7 db "en",0

prepo_es_array dw prepo_es0, prepo_es1, prepo_es2, prepo_es3, prepo_es4, prepo_es5, prepo_es6, prepo_es7

_prepo_array_cx equ 8d
;; </PREPOSICIONES Y LOCUCIONES PREPOSITIVAS EN CASTELLANO>

;; <PREPOSICIONES Y LOCUCIONES PREPOSITIVAS EN INGLES>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; prepo_enXX OPTIMIZADO 20210408, reutilizando punteros para los sinonimos. ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
prepo_en0 db "with",0
prepo_en1 db "about",0
;prepo_en2 db "about",0
;prepo_en3 db "about",0
prepo_en4 db "to",0
prepo_en5 db "to",0
prepo_en6 db "on",0
prepo_en7 db "on",0

prepo_en_array dw prepo_en0, prepo_en1, prepo_en1, prepo_en1, prepo_en4, prepo_en5, prepo_en6, prepo_en7
;; </PREPOSICIONES Y LOCUCIONES PREPOSITIVAS EN INGLES>

;; <VERBOS EN CASTELLANO>
; OJO!!! "mirar en" tiene que ir antes que "mirar". O "buscar a" tiene que ir
;  antes que "buscar". Si no el verbo mas largo no "matcheara" nunca.
; y en verbo_es|nombre_es|prepo_es NO DEBE haber sinonimos. Sinonimos solo en ingles.
verbo_es0 db "mirar en",0
verbo_es1 db "mirar dentro",0
verbo_es2 db "encender",0
verbo_es3 db "apagar",0
verbo_es4 db "mirar debajo",0
verbo_es5 db "mirar",0
verbo_es6 db "entrar",0
verbo_es7 db "despertarse",0
verbo_es8 db "despertar",0
verbo_es9 db "abrir puerta con llave",0
verbo_es10 db "cerrar puerta con llave",0
verbo_es11 db "abrir con llave",0
verbo_es12 db "cerrar con llave",0
verbo_es13 db "desbloquear",0
verbo_es14 db "desatrancar",0
verbo_es15 db "destrabar",0
verbo_es16 db "bloquear",0
verbo_es17 db "trabar",0
verbo_es18 db "atrancar",0
verbo_es19 db "coger",0
verbo_es20 db "rellenar",0
verbo_es21 db "llenar",0
verbo_es22 db "ayuda",0
verbo_es23 db "abrir",0
verbo_es24 db "pulsar",0
verbo_es25 db "presionar",0
verbo_es26 db "empujar",0
verbo_es27 db "tirar del",0
verbo_es28 db "tirar de",0
verbo_es29 db "usar",0
verbo_es30 db "llamar a la puerta",0
verbo_es31 db "llamar a puerta",0
verbo_es32 db "llamar puerta",0
verbo_es33 db "llamar al timbre",0
verbo_es34 db "llamar a timbre",0
verbo_es35 db "llamar timbre",0
verbo_es36 db "picar",0
verbo_es37 db "llamar",0
verbo_es38 db "dejar",0
verbo_es39 db "tocar la guitarra",0
verbo_es40 db "tocar guitarra",0
verbo_es41 db "tocar",0
verbo_es42 db "adios",0
verbo_es43 db "salir del juego",0
verbo_es44 db "abandonar",0
verbo_es45 db "salir",0
verbo_es46 db "salvar",0
verbo_es47 db "grabar",0
verbo_es48 db "cargar",0
verbo_es49 db "reiniciar",0
verbo_es50 db "dar",0
verbo_es51 db "entregar",0
verbo_es52 db "enviar",0
verbo_es53 db "mandar",0
verbo_es54 db "mostrar",0
verbo_es55 db "ense>ar",0
verbo_es56 db "ensenar",0
verbo_es57 db "sentarse",0
verbo_es58 db "sentar",0
verbo_es59 db "derramar",0
verbo_es60 db "verter",0
verbo_es61 db "echar helmut por",0
verbo_es62 db "echar",0
verbo_es63 db "saltar",0
verbo_es64 db "escalar",0
verbo_es65 db "subir",0
verbo_es66 db "trepar",0
verbo_es67 db "responder",0
verbo_es68 db "contestar",0
verbo_es69 db "beber",0
verbo_es70 db "invertir",0
verbo_es71 db "girar",0
verbo_es72 db "cambiar",0
verbo_es73 db "ponerse de pie",0
verbo_es74 db "levantarse",0
verbo_es75 db "vestirse",0
verbo_es76 db "vestir",0
verbo_es77 db "llevar",0
verbo_es78 db "ponerse",0
verbo_es79 db "poner helmut en",0
verbo_es80 db "colocar",0
verbo_es81 db "poner",0
verbo_es82 db "meter",0
verbo_es83 db "atar",0
verbo_es84 db "enganchar",0
verbo_es85 db "bajar helmut por",0
verbo_es86 db "hacer dedo",0
verbo_es87 db "hacer autoestop",0
verbo_es88 db "hacer autostop",0
verbo_es89 db "levantar pulgar",0
verbo_es90 db "levantar dedo",0
verbo_es91 db "parar",0
verbo_es92 db "para",0
verbo_es93 db "bailar",0
verbo_es94 db "arreglar",0
verbo_es95 db "deslizarse",0
verbo_es96 db "deslizar",0
verbo_es97 db "bajar por",0
verbo_es98 db "bajar",0
verbo_es99 db "liberar",0
verbo_es100 db "soltar",0
verbo_es101 db "salir de",0
verbo_es102 db "extender",0
verbo_es103 db "untar",0
verbo_es104 db "perdon",0
verbo_es105 db "lo siento",0
verbo_es106 db "cantar",0
verbo_es107 db "preguntar sobre",0
verbo_es108 db "preguntar por",0
verbo_es109 db "pedir",0
verbo_es110 db "puntuacion",0
verbo_es111 db "puntos",0
verbo_es112 db "cerrar",0
verbo_es113 db "saborear",0
verbo_es114 db "probar",0
verbo_es115 db "escuchar",0
verbo_es116 db "leer",0
verbo_es117 db "examinar",0
verbo_es118 db "dime",0
verbo_es119 db "cuentame",0
verbo_es120 db "hablar",0
verbo_es121 db "quien es",0
verbo_es122 db "buscar",0
verbo_es123 db "inventario",0
verbo_es124 db "levantar",0
verbo_es125 db "mover",0
verbo_es126 db "comer",0
verbo_es127 db "preguntar",0
verbo_es128 db "besar",0
verbo_es129 db "lanzar",0
verbo_es130 db "tirar",0
verbo_es131 db "dormir",0
verbo_es132 db "hola",0
verbo_es133 db "pegar",0
verbo_es134 db "joder",0
verbo_es135 db "follar",0
verbo_es136 db "oler",0

verbo_es_array dw verbo_es0, verbo_es1, verbo_es2, verbo_es3, verbo_es4, verbo_es5, verbo_es6, verbo_es7, verbo_es8, verbo_es9, verbo_es10, verbo_es11, verbo_es12, verbo_es13, verbo_es14, verbo_es15, verbo_es16, verbo_es17, verbo_es18, verbo_es19, verbo_es20, verbo_es21, verbo_es22, verbo_es23, verbo_es24, verbo_es25, verbo_es26, verbo_es27, verbo_es28, verbo_es29, verbo_es30, verbo_es31, verbo_es32, verbo_es33, verbo_es34, verbo_es35, verbo_es36, verbo_es37, verbo_es38, verbo_es39, verbo_es40, verbo_es41, verbo_es42, verbo_es43, verbo_es44, verbo_es45, verbo_es46, verbo_es47, verbo_es48, verbo_es49, verbo_es50, verbo_es51, verbo_es52, verbo_es53, verbo_es54, verbo_es55, verbo_es56, verbo_es57, verbo_es58, verbo_es59, verbo_es60, verbo_es61, verbo_es62, verbo_es63, verbo_es64, verbo_es65, verbo_es66, verbo_es67, verbo_es68, verbo_es69, verbo_es70, verbo_es71, verbo_es72, verbo_es73, verbo_es74, verbo_es75, verbo_es76, verbo_es77, verbo_es78, verbo_es79, verbo_es80, verbo_es81, verbo_es82, verbo_es83, verbo_es84, verbo_es85, verbo_es86, verbo_es87, verbo_es88, verbo_es89, verbo_es90, verbo_es91, verbo_es92, verbo_es93, verbo_es94, verbo_es95, verbo_es96, verbo_es97, verbo_es98, verbo_es99, verbo_es100, verbo_es101, verbo_es102, verbo_es103, verbo_es104, verbo_es105, verbo_es106, verbo_es107, verbo_es108, verbo_es109, verbo_es110, verbo_es111, verbo_es112, verbo_es113, verbo_es114, verbo_es115, verbo_es116, verbo_es117, verbo_es118, verbo_es119, verbo_es120, verbo_es121, verbo_es122, verbo_es123, verbo_es124, verbo_es125, verbo_es126, verbo_es127, verbo_es128, verbo_es129, verbo_es130, verbo_es131, verbo_es132, verbo_es133, verbo_es134, verbo_es135, verbo_es136

_verbo_array_cx equ 137d
;; </VERBOS EN CASTELLANO>

;; <VERBOS EN INGLES>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; verbo_enXX OPTIMIZADO 20210408, reutilizando punteros para los sinonimos. ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
verbo_en0 db "look in",0
;verbo_en1 db "look in",0
verbo_en2 db "turn on",0
verbo_en3 db "turn off",0
verbo_en4 db "look under",0
verbo_en5 db "look",0
;verbo_en6 db "look",0
verbo_en7 db "wake up",0
verbo_en8 db "awaken",0
verbo_en9 db "unlock door",0
verbo_en10 db "lock door",0
verbo_en11 db "unlock",0
verbo_en12 db "lock",0
;verbo_en13 db "unlock",0
;verbo_en14 db "unlock",0
;verbo_en15 db "unlock",0
;verbo_en16 db "lock",0
;verbo_en17 db "lock",0
;verbo_en18 db "lock",0
verbo_en19 db "take",0
verbo_en20 db "fill",0
;verbo_en21 db "fill",0
verbo_en22 db "help",0
verbo_en23 db "open",0
verbo_en24 db "push",0
;verbo_en25 db "push",0
;verbo_en26 db "push",0
verbo_en27 db "pull",0
;verbo_en28 db "pull",0
verbo_en29 db "use",0
verbo_en30 db "knock door",0
;verbo_en31 db "knock door",0
;verbo_en32 db "knock door",0
;verbo_en33 db "knock door",0
;verbo_en34 db "knock door",0
;verbo_en35 db "knock door",0
verbo_en36 db "knock",0
verbo_en37 db "call",0
verbo_en38 db "drop",0
verbo_en39 db "play guitar",0
;verbo_en40 db "play guitar",0
verbo_en41 db "touch",0
verbo_en42 db "bye",0
verbo_en43 db "quit",0
;verbo_en44 db "quit",0
verbo_en45 db "exit",0
verbo_en46 db "save",0
;verbo_en47 db "save",0
verbo_en48 db "load",0
verbo_en49 db "restart",0
verbo_en50 db "give",0
;verbo_en51 db "give",0
verbo_en52 db "send",0
;verbo_en53 db "send",0
verbo_en54 db "show",0
;verbo_en55 db "show",0
;verbo_en56 db "show",0
verbo_en57 db "sit",0
;verbo_en58 db "sit",0
verbo_en59 db "spill",0
;verbo_en60 db "spill",0
verbo_en61 db "lower helmut in",0
;verbo_en62 db "spill",0
verbo_en63 db "climb",0
;verbo_en64 db "climb",0
;verbo_en65 db "climb",0
;verbo_en66 db "climb",0
verbo_en67 db "answer",0
;verbo_en68 db "answer",0
verbo_en69 db "drink",0
verbo_en70 db "reverse",0
;verbo_en71 db "reverse",0
;verbo_en72 db "reverse",0
verbo_en73 db "get up",0
;verbo_en74 db "get up",0
verbo_en75 db "wear",0
;verbo_en76 db "wear",0
;verbo_en77 db "wear",0
;verbo_en78 db "wear",0
verbo_en79 db "place helmut in",0
verbo_en80 db "place",0
;verbo_en81 db "place",0
;verbo_en82 db "place",0
verbo_en83 db "tie",0
;verbo_en84 db "tie",0
verbo_en85 db "lower helmut in",0
verbo_en86 db "thumb",0
;verbo_en87 db "thumb",0
;verbo_en88 db "thumb",0
;verbo_en89 db "thumb",0
;verbo_en90 db "thumb",0
verbo_en91 db "stop",0
;verbo_en92 db "stop",0
verbo_en93 db "dance",0
verbo_en94 db "fix",0
verbo_en95 db "slide",0
;verbo_en96 db "slide",0
;verbo_en97 db "slide",0
verbo_en98 db "lower",0
verbo_en99 db "release",0
;verbo_en100 db "release",0
;verbo_en101 db "release",0
verbo_en102 db "spread",0
;verbo_en103 db "spread",0
verbo_en104 db "excuse",0
;verbo_en105 db "excuse",0
verbo_en106 db "sing",0
verbo_en107 db "ask about",0
;verbo_en108 db "ask about",0
verbo_en109 db "ask for",0
verbo_en110 db "score",0
;verbo_en111 db "score",0
verbo_en112 db "close",0
verbo_en113 db "taste",0
;verbo_en114 db "taste",0
verbo_en115 db "listen",0
verbo_en116 db "read",0
verbo_en117 db "examine",0
verbo_en118 db "tell me about",0
;verbo_en119 db "tell me about",0
verbo_en120 db "talk to",0
verbo_en121 db "who is",0
verbo_en122 db "search for",0
verbo_en123 db "inventory",0
verbo_en124 db "lift",0
verbo_en125 db "move",0
verbo_en126 db "eat",0
verbo_en127 db "ask",0
verbo_en128 db "kiss",0
verbo_en129 db "throw",0
;verbo_en130 db "throw",0
verbo_en131 db "sleep",0
verbo_en132 db "hello",0
verbo_en133 db "kick",0
verbo_en134 db "fuck",0
;verbo_en135 db "fuck",0
verbo_en136 db "smell",0

verbo_en_array dw verbo_en0, verbo_en0, verbo_en2, verbo_en3, verbo_en4, verbo_en5, verbo_en5, verbo_en7, verbo_en8, verbo_en9, verbo_en10, verbo_en11, verbo_en12, verbo_en11, verbo_en11, verbo_en11, verbo_en12, verbo_en12, verbo_en12, verbo_en19, verbo_en20, verbo_en20, verbo_en22, verbo_en23, verbo_en24, verbo_en24, verbo_en24, verbo_en27, verbo_en27, verbo_en29, verbo_en30, verbo_en30, verbo_en30, verbo_en30, verbo_en30, verbo_en30, verbo_en36, verbo_en37, verbo_en38, verbo_en39, verbo_en39, verbo_en41, verbo_en42, verbo_en43, verbo_en43, verbo_en45, verbo_en46, verbo_en46, verbo_en48, verbo_en49, verbo_en50, verbo_en50, verbo_en52, verbo_en52, verbo_en54, verbo_en54, verbo_en54, verbo_en57, verbo_en57, verbo_en59, verbo_en59, verbo_en61, verbo_en59, verbo_en63, verbo_en63, verbo_en63, verbo_en63, verbo_en67, verbo_en67, verbo_en69, verbo_en70, verbo_en70, verbo_en70, verbo_en73, verbo_en73, verbo_en75, verbo_en75, verbo_en75, verbo_en75, verbo_en79, verbo_en80, verbo_en80, verbo_en80, verbo_en83, verbo_en83, verbo_en85, verbo_en86, verbo_en86, verbo_en86, verbo_en86, verbo_en86, verbo_en91, verbo_en91, verbo_en93, verbo_en94, verbo_en95, verbo_en95, verbo_en95, verbo_en98, verbo_en99, verbo_en99, verbo_en99, verbo_en102, verbo_en102, verbo_en104, verbo_en104, verbo_en106, verbo_en107, verbo_en107, verbo_en109, verbo_en110, verbo_en110, verbo_en112, verbo_en113, verbo_en113, verbo_en115, verbo_en116, verbo_en117, verbo_en118, verbo_en118, verbo_en120, verbo_en121, verbo_en122, verbo_en123, verbo_en124, verbo_en125, verbo_en126, verbo_en127, verbo_en128, verbo_en129, verbo_en129, verbo_en131, verbo_en132, verbo_en133, verbo_en134, verbo_en134, verbo_en136
;; </VERBOS EN INGLES>

;; <NOMBRES EN CASTELLANO>
nombre_es0 db "suelo",0
nombre_es1 db "edificio",0
nombre_es2 db "aire",0
nombre_es3 db "polvo",0
nombre_es4 db "manos",0
nombre_es5 db "cielo",0
nombre_es6 db "pared",0
nombre_es7 db "grupo",0
nombre_es8 db "nombre",0
nombre_es9 db "sexo",0
nombre_es10 db "archivador",0
nombre_es11 db "armario",0
nombre_es12 db "calendario",0
nombre_es13 db "bombilla",0
nombre_es14 db "luz",0
nombre_es15 db "escritorio",0
nombre_es16 db "reloj",0
nombre_es17 db "tetas",0
nombre_es18 db "pechos",0
nombre_es19 db "cajon",0
nombre_es20 db "termo",0
nombre_es21 db "bolsa",0
nombre_es22 db "pan",0
nombre_es23 db "mantequilla",0
nombre_es24 db "cacahuete",0
nombre_es25 db "silla",0
nombre_es26 db "telefono",0
nombre_es27 db "almacen",0
nombre_es28 db "fuente",0
nombre_es29 db "tanque",0
nombre_es30 db "agua potable",0
nombre_es31 db "agua",0
nombre_es32 db "caja de herramientas",0
nombre_es33 db "herramientas",0
nombre_es34 db "identificacion",0
nombre_es35 db "carnet",0
nombre_es36 db "boton",0
nombre_es37 db "tele",0
nombre_es38 db "tv",0
nombre_es39 db "libros",0
nombre_es40 db "libro",0
nombre_es41 db "manojo de llaves",0
nombre_es42 db "llave maestra",0
nombre_es43 db "llaves",0
nombre_es44 db "llave",0
nombre_es45 db "aumento",0
nombre_es46 db "sueldo",0
nombre_es47 db "salario",0
nombre_es48 db "dinero",0
nombre_es49 db "arbol",0
nombre_es50 db "planta",0
nombre_es51 db "maceta",0
nombre_es52 db "sue>o",0
nombre_es53 db "sueno",0
nombre_es54 db "pesadilla",0
nombre_es55 db "autobus",0
nombre_es56 db "carrito de bebe",0
nombre_es57 db "bebe",0
nombre_es58 db "nino",0
nombre_es59 db "madre",0
nombre_es60 db "contador",0
nombre_es61 db "mostrador",0
nombre_es62 db "encimera",0
nombre_es63 db "marmol",0
nombre_es64 db "barra de bar",0
nombre_es65 db "reservado",0
nombre_es66 db "revisor",0
nombre_es67 db "maquina",0
nombre_es68 db "ventana",0
nombre_es69 db "buzon",0
nombre_es70 db "cartel de alquiler",0
nombre_es71 db "alquiler",0
nombre_es72 db "letrero",0
nombre_es73 db "anuncio",0
nombre_es74 db "aviso",0
nombre_es75 db "cartel luminoso",0
nombre_es76 db "cartel de no molestar",0
nombre_es77 db "cartelito",0
nombre_es78 db "cartel",0
nombre_es79 db "carta",0
nombre_es80 db "boca de incendios",0
nombre_es81 db "hidrante",0
nombre_es82 db "charco",0
nombre_es83 db "reflejo",0
nombre_es84 db "alcantarilla",0
nombre_es85 db "sumidero",0
nombre_es86 db "cloaca",0
nombre_es87 db "desague",0
nombre_es88 db "verja",0
nombre_es89 db "reja",0
nombre_es90 db "valla",0
nombre_es91 db "tapia",0
nombre_es92 db "multitud",0
nombre_es93 db "gentio",0
nombre_es94 db "gente",0
nombre_es95 db "globos",0
nombre_es96 db "globo",0
nombre_es97 db "tendedero",0
nombre_es98 db "cosa",0
nombre_es99 db "timbre",0
nombre_es100 db "voz",0
nombre_es101 db "mirilla",0
nombre_es102 db "desechos",0
nombre_es103 db "basura",0
nombre_es104 db "desperdicios",0
nombre_es105 db "tiempo",0
nombre_es106 db "clima",0
nombre_es107 db "sudor",0
nombre_es108 db "bebida",0
nombre_es109 db "gaseosa",0
nombre_es110 db "refresco",0
nombre_es111 db "soda",0
nombre_es112 db "cafe",0
nombre_es113 db "sofa",0
nombre_es114 db "sillon",0
nombre_es115 db "canape",0
nombre_es116 db "divan",0
nombre_es117 db "concierto",0
nombre_es118 db "recital",0
nombre_es119 db "espectaculo",0
nombre_es120 db "decoracion",0
nombre_es121 db "bufanda",0
nombre_es122 db "poderes",0
nombre_es123 db "curacion",0
nombre_es124 db "rey",0
nombre_es125 db "pakolmo",0
nombre_es126 db "danstructor",0
nombre_es127 db "gatuno",0
nombre_es128 db "cireja",0
nombre_es129 db "gato",0
nombre_es130 db "elefantes",0
nombre_es131 db "elefante",0
nombre_es132 db "trabajo",0
nombre_es133 db "boleto",0
nombre_es134 db "entrada",0
nombre_es135 db "caravana",0
nombre_es136 db "chuleta",0
nombre_es137 db "bistec",0
nombre_es138 db "leones",0
nombre_es139 db "leon",0
nombre_es140 db "agujero",0
nombre_es141 db "bache",0
nombre_es142 db "hoyo",0
nombre_es143 db "peldanos",0
nombre_es144 db "peldano",0
nombre_es145 db "escalones",0
nombre_es146 db "escalon",0
nombre_es147 db "capa",0
nombre_es148 db "vagon",0
nombre_es149 db "carromato",0
nombre_es150 db "carro",0
nombre_es151 db "cebra",0
nombre_es152 db "toldo",0
nombre_es153 db "palomitas",0
nombre_es154 db "payaso",0
nombre_es155 db "bola de cristal",0
nombre_es156 db "bola",0
nombre_es157 db "vela",0
nombre_es158 db "llama",0
nombre_es159 db "ojos",0
nombre_es160 db "ojo",0
nombre_es161 db "lagarto",0
nombre_es162 db "lagartija",0
nombre_es163 db "salamandra",0
nombre_es164 db "sala",0
nombre_es165 db "craneo",0
nombre_es166 db "calavera",0
nombre_es167 db "labios",0
nombre_es168 db "tarjeta de resurreccion",0
nombre_es169 db "tarjeta",0
nombre_es170 db "bigote",0
nombre_es171 db "peso",0
nombre_es172 db "pesas",0
nombre_es173 db "pesa",0
nombre_es174 db "diferencia",0
nombre_es175 db "resina",0
nombre_es176 db "monociclista",0
nombre_es177 db "gorda",0
nombre_es178 db "fortuna",0
nombre_es179 db "pala",0
nombre_es180 db "cola",0
nombre_es181 db "jaula",0
nombre_es182 db "mierda",0
nombre_es183 db "caca",0
nombre_es184 db "telefono",0
nombre_es185 db "viaje",0
nombre_es186 db "palmeras",0
nombre_es187 db "palmera",0
nombre_es188 db "familia",0
nombre_es189 db "domingueros",0
nombre_es190 db "habitacion",0
nombre_es191 db "cuerdas",0
nombre_es192 db "cuerda",0
nombre_es193 db "sogas",0
nombre_es194 db "soga",0
nombre_es195 db "registro de invitados",0
nombre_es196 db "invitados",0
nombre_es197 db "huespedes",0
nombre_es198 db "clientes",0
nombre_es199 db "cenicero",0
nombre_es200 db "limpiadores",0
nombre_es201 db "limpiadoras",0
nombre_es202 db "retrato",0
nombre_es203 db "programa",0
nombre_es204 db "horario",0
nombre_es205 db "botones",0
nombre_es206 db "traje",0
nombre_es207 db "pintura",0
nombre_es208 db "aseo",0
nombre_es209 db "lavabo",0
nombre_es210 db "ba>o",0
nombre_es211 db "bano",0
nombre_es212 db "hilo dental",0
nombre_es213 db "pica",0
nombre_es214 db "ba>era",0
nombre_es215 db "banera",0
nombre_es216 db "retrete",0
nombre_es217 db "inodoro",0
nombre_es218 db "letrina",0
nombre_es219 db "water",0
nombre_es220 db "vater",0
nombre_es221 db "aceite",0
nombre_es222 db "banda",0
nombre_es223 db "tira",0
nombre_es224 db "franja",0
nombre_es225 db "tela",0
nombre_es226 db "carrito",0
nombre_es227 db "toallas",0
nombre_es228 db "jabon",0
nombre_es229 db "lejia",0
nombre_es230 db "aspiradora",0
nombre_es231 db "aspirador",0
nombre_es232 db "camilla",0
nombre_es233 db "mesa",0
nombre_es234 db "lampara",0
nombre_es235 db "escaleras",0
nombre_es236 db "escalera",0
nombre_es237 db "jacuzzi",0
nombre_es238 db "recibo",0
nombre_es239 db "resguardo",0
nombre_es240 db "piscina",0
nombre_es241 db "mujeres",0
nombre_es242 db "mujer bebiendo",0
nombre_es243 db "mujer flotante",0
nombre_es244 db "mujer sedienta",0
nombre_es245 db "mujer",0
nombre_es246 db "sentado",0
nombre_es247 db "hombres",0
nombre_es248 db "hombre andando",0
nombre_es249 db "hombre sentado",0
nombre_es250 db "hombre",0
nombre_es251 db "tumbona",0
nombre_es252 db "gafas",0
nombre_es253 db "roca",0
nombre_es254 db "piedra",0
nombre_es255 db "barricada",0
nombre_es256 db "barrera",0
nombre_es257 db "obstaculo",0
nombre_es258 db "buitre",0
nombre_es259 db "pajaro",0
nombre_es260 db "escenario",0
nombre_es261 db "tunel",0
nombre_es262 db "paso subterraneo",0
nombre_es263 db "cuadros",0
nombre_es264 db "pinturas",0
nombre_es265 db "cuadro",0
nombre_es266 db "retrato",0
nombre_es267 db "figura",0
nombre_es268 db "foto",0
nombre_es269 db "recortable",0
nombre_es270 db "pelota",0
nombre_es271 db "alfombra",0
nombre_es272 db "oso",0
nombre_es273 db "escalinata",0
nombre_es274 db "boca",0
nombre_es275 db "interruptor",0
nombre_es276 db "alarma",0
nombre_es277 db "guitarra",0
nombre_es278 db "microfono",0
nombre_es279 db "mono",0
nombre_es280 db "trofeos",0
nombre_es281 db "premios",0
nombre_es282 db "trofeo",0
nombre_es283 db "vitrina",0
nombre_es284 db "escaparate",0
nombre_es285 db "palo",0
nombre_es286 db "barandilla",0
nombre_es287 db "barra",0
nombre_es288 db "oficina",0
nombre_es289 db "secreto",0
nombre_es290 db "mecanismo",0
nombre_es291 db "cama",0
nombre_es292 db "espejo",0
nombre_es293 db "premios",0
nombre_es294 db "premio",0
nombre_es295 db "cocina",0
nombre_es296 db "fogon",0
nombre_es297 db "horno",0
nombre_es298 db "taburetes",0
nombre_es299 db "taburete",0
nombre_es300 db "gramola",0
nombre_es301 db "tocadiscos",0
nombre_es302 db "condimentos",0
nombre_es303 db "especias",0
nombre_es304 db "sazones",0
nombre_es305 db "aderezos",0
nombre_es306 db "mostaza",0
nombre_es307 db "bocata",0
nombre_es308 db "bocadillo",0
nombre_es309 db "frutero",0
nombre_es310 db "fruta",0
nombre_es311 db "cuenco",0
nombre_es312 db "platano",0
nombre_es313 db "chica",0
nombre_es314 db "tia",0
nombre_es315 db "puerta",0
nombre_es316 db "cerradura",0
nombre_es317 db "cerrojo",0
nombre_es318 db "coche",0
nombre_es319 db "techo",0
nombre_es320 db "caja",0
nombre_es321 db "ascensor",0
nombre_es322 db "estanteria",0
nombre_es323 db "futuro",0
nombre_es324 db "casa",0
nombre_es325 db "cera",0
nombre_es326 db "coca",0
nombre_es327 db "objetivo",0
nombre_es328 db "culo",0
nombre_es329 db "vaso",0
nombre_es330 db "tarro",0
nombre_es331 db "bote",0
nombre_es332 db "circo",0
nombre_es333 db "martillo",0
nombre_es334 db "conmigo",0
nombre_es335 db "mismo",0
nombre_es336 db "placa",0
nombre_es337 db "stella",0
nombre_es338 db "helmut por correo",0
nombre_es339 db "helmut",0
nombre_es340 db "luigi",0
nombre_es341 db "bobbi",0
nombre_es342 db "bernardo",0
nombre_es343 db "bob",0
nombre_es344 db "coronel",0
nombre_es345 db "jefe",0
nombre_es346 db "burnbaum",0
nombre_es347 db "vidente",0
nombre_es348 db "zarmooska",0
nombre_es349 db "lyla",0
nombre_es350 db "vito",0
nombre_es351 db "guardaespaldas",0
nombre_es352 db "alona",0
nombre_es353 db "ayudante",0
nombre_es354 db "fred",0
nombre_es355 db "susie",0
nombre_es356 db "fabuloso",0
nombre_es357 db "criada",0
nombre_es358 db "limpiadora",0
nombre_es359 db "limpieza",0
nombre_es360 db "lino",0
nombre_es361 db "linillo",0

nombre_es_array:
dw nombre_es0, nombre_es1, nombre_es2, nombre_es3, nombre_es4, nombre_es5, nombre_es6, nombre_es7, nombre_es8, nombre_es9, nombre_es10, nombre_es11, nombre_es12, nombre_es13, nombre_es14, nombre_es15, nombre_es16, nombre_es17, nombre_es18, nombre_es19, nombre_es20, nombre_es21, nombre_es22, nombre_es23, nombre_es24, nombre_es25, nombre_es26, nombre_es27, nombre_es28, nombre_es29, nombre_es30, nombre_es31, nombre_es32, nombre_es33, nombre_es34, nombre_es35, nombre_es36, nombre_es37, nombre_es38, nombre_es39, nombre_es40, nombre_es41, nombre_es42, nombre_es43, nombre_es44, nombre_es45, nombre_es46, nombre_es47, nombre_es48, nombre_es49, nombre_es50, nombre_es51, nombre_es52, nombre_es53, nombre_es54, nombre_es55, nombre_es56, nombre_es57, nombre_es58, nombre_es59, nombre_es60, nombre_es61, nombre_es62, nombre_es63, nombre_es64, nombre_es65, nombre_es66, nombre_es67, nombre_es68, nombre_es69, nombre_es70, nombre_es71, nombre_es72, nombre_es73, nombre_es74, nombre_es75, nombre_es76, nombre_es77, nombre_es78, nombre_es79, nombre_es80, nombre_es81, nombre_es82, nombre_es83, nombre_es84, nombre_es85, nombre_es86, nombre_es87, nombre_es88, nombre_es89, nombre_es90, nombre_es91, nombre_es92, nombre_es93, nombre_es94, nombre_es95, nombre_es96, nombre_es97, nombre_es98, nombre_es99, nombre_es100
dw nombre_es101, nombre_es102, nombre_es103, nombre_es104, nombre_es105, nombre_es106, nombre_es107, nombre_es108, nombre_es109, nombre_es110, nombre_es111, nombre_es112, nombre_es113, nombre_es114, nombre_es115, nombre_es116, nombre_es117, nombre_es118, nombre_es119, nombre_es120, nombre_es121, nombre_es122, nombre_es123, nombre_es124, nombre_es125, nombre_es126, nombre_es127, nombre_es128, nombre_es129, nombre_es130, nombre_es131, nombre_es132, nombre_es133, nombre_es134, nombre_es135, nombre_es136, nombre_es137, nombre_es138, nombre_es139, nombre_es140, nombre_es141, nombre_es142, nombre_es143, nombre_es144, nombre_es145, nombre_es146, nombre_es147, nombre_es148, nombre_es149, nombre_es150, nombre_es151, nombre_es152, nombre_es153, nombre_es154, nombre_es155, nombre_es156, nombre_es157, nombre_es158, nombre_es159, nombre_es160, nombre_es161, nombre_es162, nombre_es163, nombre_es164, nombre_es165, nombre_es166, nombre_es167, nombre_es168, nombre_es169, nombre_es170, nombre_es171, nombre_es172, nombre_es173, nombre_es174, nombre_es175, nombre_es176, nombre_es177, nombre_es178, nombre_es179, nombre_es180, nombre_es181, nombre_es182, nombre_es183, nombre_es184, nombre_es185, nombre_es186, nombre_es187, nombre_es188, nombre_es189, nombre_es190, nombre_es191, nombre_es192, nombre_es193, nombre_es194, nombre_es195, nombre_es196, nombre_es197, nombre_es198, nombre_es199, nombre_es200
dw nombre_es201, nombre_es202, nombre_es203, nombre_es204, nombre_es205, nombre_es206, nombre_es207, nombre_es208, nombre_es209, nombre_es210, nombre_es211, nombre_es212, nombre_es213, nombre_es214, nombre_es215, nombre_es216, nombre_es217, nombre_es218, nombre_es219, nombre_es220, nombre_es221, nombre_es222, nombre_es223, nombre_es224, nombre_es225, nombre_es226, nombre_es227, nombre_es228, nombre_es229, nombre_es230, nombre_es231, nombre_es232, nombre_es233, nombre_es234, nombre_es235, nombre_es236, nombre_es237, nombre_es238, nombre_es239, nombre_es240, nombre_es241, nombre_es242, nombre_es243, nombre_es244, nombre_es245, nombre_es246, nombre_es247, nombre_es248, nombre_es249, nombre_es250, nombre_es251, nombre_es252, nombre_es253, nombre_es254, nombre_es255, nombre_es256, nombre_es257, nombre_es258, nombre_es259, nombre_es260, nombre_es261, nombre_es262, nombre_es263, nombre_es264, nombre_es265, nombre_es266, nombre_es267, nombre_es268, nombre_es269, nombre_es270, nombre_es271, nombre_es272, nombre_es273, nombre_es274, nombre_es275, nombre_es276, nombre_es277, nombre_es278, nombre_es279, nombre_es280, nombre_es281, nombre_es282, nombre_es283, nombre_es284, nombre_es285, nombre_es286, nombre_es287, nombre_es288, nombre_es289, nombre_es290, nombre_es291, nombre_es292, nombre_es293, nombre_es294, nombre_es295, nombre_es296, nombre_es297, nombre_es298, nombre_es299, nombre_es300
dw nombre_es301, nombre_es302, nombre_es303, nombre_es304, nombre_es305, nombre_es306, nombre_es307, nombre_es308, nombre_es309, nombre_es310, nombre_es311, nombre_es312, nombre_es313, nombre_es314, nombre_es315, nombre_es316, nombre_es317, nombre_es318, nombre_es319, nombre_es320, nombre_es321, nombre_es322, nombre_es323, nombre_es324, nombre_es325, nombre_es326, nombre_es327, nombre_es328, nombre_es329, nombre_es330, nombre_es331, nombre_es332, nombre_es333, nombre_es334, nombre_es335, nombre_es336, nombre_es337, nombre_es338, nombre_es339, nombre_es340, nombre_es341, nombre_es342, nombre_es343, nombre_es344, nombre_es345, nombre_es346, nombre_es347, nombre_es348, nombre_es349, nombre_es350, nombre_es351, nombre_es352, nombre_es353, nombre_es354, nombre_es355, nombre_es356, nombre_es357, nombre_es358, nombre_es359, nombre_es360, nombre_es361

_nombre_array_cx equ 362d
;; </NOMBRES EN CASTELLANO>

;; <NOMBRES EN INGLES>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; nombre_enXX OPTIMIZADO 20210408, reutilizando punteros para los sinonimos. ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
nombre_en0 db "ground",0
nombre_en1 db "building",0
nombre_en2 db "air",0
nombre_en3 db "dust",0
nombre_en4 db "hands",0
nombre_en5 db "ceiling",0
nombre_en6 db "wall",0
nombre_en7 db "group",0
nombre_en8 db "name",0
nombre_en9 db "sex",0
nombre_en10 db "file",0
nombre_en11 db "cabinet",0
nombre_en12 db "calendar",0
nombre_en13 db "light",0
;nombre_en14 db "light",0
nombre_en15 db "desk",0
nombre_en16 db "wrist",0
nombre_en17 db "tits",0
;nombre_en18 db "tits",0
nombre_en19 db "drawer",0
nombre_en20 db "thermos",0
nombre_en21 db "bag",0
nombre_en22 db "bread",0
nombre_en23 db "butter",0
nombre_en24 db "peanut",0
nombre_en25 db "chair",0
nombre_en26 db "telephone",0
nombre_en27 db "storeroom",0
nombre_en28 db "fountain",0
nombre_en29 db "tank",0
nombre_en30 db "drinkable",0
nombre_en31 db "water",0
nombre_en32 db "toolbox",0
nombre_en33 db "tools",0
nombre_en34 db "ID",0
nombre_en35 db "ID",0
nombre_en36 db "button",0
nombre_en37 db "television",0
;nombre_en38 db "television",0
nombre_en39 db "books",0
nombre_en40 db "book",0
nombre_en41 db "master key",0
nombre_en42 db "skeleton key",0
nombre_en43 db "keys",0
nombre_en44 db "key",0
nombre_en45 db "raise",0
;nombre_en46 db "raise",0
;nombre_en47 db "raise",0
;nombre_en48 db "raise",0
nombre_en49 db "tree",0
;nombre_en50 db "tree",0
;nombre_en51 db "tree",0
nombre_en52 db "dream",0
;nombre_en53 db "dream",0
;nombre_en54 db "dream",0
nombre_en55 db "Bus",0
nombre_en56 db "stroller",0
nombre_en57 db "baby",0
;nombre_en58 db "baby",0
nombre_en59 db "mother",0
nombre_en60 db "counter",0
;nombre_en61 db "counter",0
;nombre_en62 db "counter",0
;nombre_en63 db "counter",0
;nombre_en64 db "counter",0
;nombre_en65 db "counter",0
nombre_en66 db "clerk",0
nombre_en67 db "vending",0
nombre_en68 db "window",0
nombre_en69 db "mailbox",0
nombre_en70 db "rent sign",0
nombre_en71 db "rent",0
nombre_en72 db "notice",0
;nombre_en73 db "notice",0
;nombre_en74 db "notice",0
nombre_en75 db "flashing sign",0
nombre_en76 db "Do-Not-Disturb sign",0
nombre_en77 db "little sign",0
nombre_en78 db "sign",0
nombre_en79 db "letter",0
nombre_en80 db "hydrant",0
;nombre_en81 db "hydrant",0
nombre_en82 db "puddle",0
nombre_en83 db "reflection",0
nombre_en84 db "drain",0
;nombre_en85 db "drain",0
;nombre_en86 db "drain",0
;nombre_en87 db "drain",0
nombre_en88 db "fence",0
;nombre_en89 db "fence",0
;nombre_en90 db "fence",0
;nombre_en91 db "fence",0
nombre_en92 db "crowd",0
;nombre_en93 db "crowd",0
;nombre_en94 db "crowd",0
nombre_en95 db "balloon",0
;nombre_en96 db "balloon",0
nombre_en97 db "clothesline",0
nombre_en98 db "thing",0
nombre_en99 db "doorbell",0
nombre_en100 db "voice",0
nombre_en101 db "peephole",0
nombre_en102 db "garbage",0
;nombre_en103 db "garbage",0
;nombre_en104 db "garbage",0
nombre_en105 db "weather",0
;nombre_en106 db "weather",0
nombre_en107 db "sweat stains",0
nombre_en108 db "soda",0
;nombre_en109 db "soda",0
;nombre_en110 db "soda",0
;nombre_en111 db "soda",0
nombre_en112 db "coffee",0
nombre_en113 db "couch",0
;nombre_en114 db "couch",0
;nombre_en115 db "couch",0
;nombre_en116 db "couch",0
nombre_en117 db "concert",0
;nombre_en118 db "concert",0
;nombre_en119 db "concert",0
nombre_en120 db "decorations",0
nombre_en121 db "scarf",0
nombre_en122 db "healing",0
;nombre_en123 db "healing",0
nombre_en124 db "king",0
;nombre_en125 db "king",0
;nombre_en126 db "king",0
;nombre_en127 db "king",0
;nombre_en128 db "king",0
;nombre_en129 db "king",0
nombre_en130 db "elephants",0
nombre_en131 db "elephant",0
nombre_en132 db "job",0
nombre_en133 db "ticket",0
;nombre_en134 db "ticket",0
nombre_en135 db "trailer",0
nombre_en136 db "steak",0
;nombre_en137 db "steak",0
nombre_en138 db "lion",0
;nombre_en139 db "lion",0
nombre_en140 db "hole",0
;nombre_en141 db "hole",0
;nombre_en142 db "hole",0
nombre_en143 db "rungs",0
;nombre_en144 db "rungs",0
;nombre_en145 db "rungs",0
;nombre_en146 db "rungs",0
nombre_en147 db "cape",0
nombre_en148 db "wagon",0
;nombre_en149 db "wagon",0
;nombre_en150 db "wagon",0
nombre_en151 db "zebra",0
nombre_en152 db "tent",0
nombre_en153 db "popcorn",0
nombre_en154 db "clown",0
nombre_en155 db "crystal ball",0
nombre_en156 db "crystal",0
nombre_en157 db "candle",0
nombre_en158 db "flame",0
nombre_en159 db "eyes",0
nombre_en160 db "eye",0
nombre_en161 db "lizard",0
;nombre_en162 db "lizard",0
;nombre_en163 db "lizard",0
nombre_en164 db "room",0
nombre_en165 db "skull",0
;nombre_en166 db "skull",0
nombre_en167 db "lips",0
nombre_en168 db "card",0
;nombre_en169 db "card",0
nombre_en170 db "mustache",0
nombre_en171 db "weight",0
;nombre_en172 db "weight",0
;nombre_en173 db "weight",0
nombre_en174 db "difference",0
nombre_en175 db "rosin",0
nombre_en176 db "unicyclist",0
nombre_en177 db "fat",0
nombre_en178 db "fortune",0
nombre_en179 db "shovel",0
nombre_en180 db "tail",0
nombre_en181 db "crate",0
nombre_en182 db "shit",0
;nombre_en183 db "shit",0
nombre_en184 db "phone",0
nombre_en185 db "ride",0
nombre_en186 db "palms",0
;nombre_en187 db "palms",0
nombre_en188 db "family",0
;nombre_en189 db "family",0
nombre_en190 db "room",0
nombre_en191 db "ropes",0
;nombre_en192 db "ropes",0
;nombre_en193 db "ropes",0
;nombre_en194 db "ropes",0
nombre_en195 db "guest register",0
nombre_en196 db "guest",0
;nombre_en197 db "guest",0
;nombre_en198 db "guest",0
nombre_en199 db "ashtray",0
nombre_en200 db "cleaners",0
;nombre_en201 db "cleaners",0
nombre_en202 db "large portrait",0
nombre_en203 db "show",0
nombre_en204 db "schedule",0
nombre_en205 db "buttons",0
nombre_en206 db "suit",0
nombre_en207 db "painting",0
nombre_en208 db "bathroom",0
;nombre_en209 db "bathroom",0
;nombre_en210 db "bathroom",0
;nombre_en211 db "bathroom",0
nombre_en212 db "dental floss",0
nombre_en213 db "sink",0
nombre_en214 db "bathtub",0
;nombre_en215 db "bathtub",0
nombre_en216 db "toilet",0
;nombre_en217 db "toilet",0
;nombre_en218 db "toilet",0
;nombre_en219 db "toilet",0
;nombre_en220 db "toilet",0
nombre_en221 db "oil",0
nombre_en222 db "strip",0
;nombre_en223 db "strip",0
;nombre_en224 db "strip",0
;nombre_en225 db "strip",0
nombre_en226 db "cart",0
nombre_en227 db "towels",0
nombre_en228 db "soap",0
nombre_en229 db "disinfectant",0
nombre_en230 db "vacuum",0
;nombre_en231 db "vacuum",0
;nombre_en232 db "couch",0
nombre_en233 db "table",0
nombre_en234 db "lamp",0
nombre_en235 db "stairs",0
nombre_en236 db "ladder",0
nombre_en237 db "hot tub",0
nombre_en238 db "receipt",0
;nombre_en239 db "receipt",0
nombre_en240 db "pool",0
nombre_en241 db "women",0
nombre_en242 db "drinking",0
nombre_en243 db "floating",0
nombre_en244 db "thirsty",0
nombre_en245 db "woman",0
nombre_en246 db "seated",0
nombre_en247 db "men",0
nombre_en248 db "walking",0
;nombre_en249 db "seated",0
nombre_en250 db "man",0
nombre_en251 db "lounge",0
nombre_en252 db "sunglasses",0
nombre_en253 db "rock",0
;nombre_en254 db "rock",0
nombre_en255 db "barricade",0
;nombre_en256 db "barricade",0
;nombre_en257 db "barricade",0
nombre_en258 db "buzzard",0
;nombre_en259 db "buzzard",0
nombre_en260 db "stage",0
nombre_en261 db "tunnel",0
;nombre_en262 db "tunnel",0
nombre_en263 db "paintings",0
;nombre_en264 db "paintings",0
nombre_en265 db "picture",0
;nombre_en266 db "picture",0
;nombre_en267 db "picture",0
;nombre_en268 db "picture",0
;nombre_en269 db "picture",0
nombre_en270 db "ball",0
nombre_en271 db "rug",0
nombre_en272 db "bear",0
nombre_en273 db "stairway",0
nombre_en274 db "mouth",0
nombre_en275 db "switch",0
nombre_en276 db "alarm",0
nombre_en277 db "guitar",0
nombre_en278 db "microphone",0
nombre_en279 db "jumpsuit",0
nombre_en280 db "trophies",0
;nombre_en281 db "trophies",0
nombre_en282 db "trophy",0
nombre_en283 db "case",0
;nombre_en284 db "case",0
nombre_en285 db "pole",0
;nombre_en286 db "pole",0
;nombre_en287 db "pole",0
nombre_en288 db "bureau",0
nombre_en289 db "secret",0
nombre_en290 db "mechanism",0
nombre_en291 db "bed",0
nombre_en292 db "mirror",0
nombre_en293 db "awards",0
;nombre_en294 db "awards",0
nombre_en295 db "kitchen",0
nombre_en296 db "stove",0
;nombre_en297 db "stove",0
nombre_en298 db "stools",0
nombre_en299 db "stool",0
nombre_en300 db "jukebox",0
;nombre_en301 db "jukebox",0
nombre_en302 db "condiments",0
;nombre_en303 db "condiments",0
;nombre_en304 db "condiments",0
;nombre_en305 db "condiments",0
nombre_en306 db "mustard",0
nombre_en307 db "sandwich",0
;nombre_en308 db "sandwich",0
nombre_en309 db "fruit bowl",0
nombre_en310 db "fruit",0
nombre_en311 db "bowl",0
nombre_en312 db "banana",0
nombre_en313 db "girl",0
;nombre_en314 db "girl",0
nombre_en315 db "door",0
;nombre_en316 db "door",0
;nombre_en317 db "door",0
nombre_en318 db "car",0
nombre_en319 db "ceiling",0
nombre_en320 db "box",0
nombre_en321 db "elevator",0
nombre_en322 db "shelves",0
nombre_en323 db "future",0
nombre_en324 db "house",0
nombre_en325 db "wax",0
nombre_en326 db "coke",0
nombre_en327 db "contest",0
nombre_en328 db "ass",0
nombre_en329 db "glass",0
nombre_en330 db "jar",0
;nombre_en331 db "jar",0
nombre_en332 db "circus",0
nombre_en333 db "hammer",0
nombre_en334 db "myself",0
;nombre_en335 db "myself",0
nombre_en336 db "plaque",0
nombre_en337 db "Stella",0
nombre_en338 db "Helmut",0
;nombre_en339 db "Helmut",0
nombre_en340 db "Luigi",0
nombre_en341 db "Bobbi",0
nombre_en342 db "Bernardo",0
nombre_en343 db "Bob",0
nombre_en344 db "colonel",0
nombre_en345 db "Burnbaum",0
;nombre_en346 db "Burnbaum",0
nombre_en347 db "Zarmooska",0
;nombre_en348 db "Zarmooska",0
nombre_en349 db "Lyla",0
nombre_en350 db "Vito",0
;nombre_en351 db "Vito",0
nombre_en352 db "Alona",0
;nombre_en353 db "Alona",0
nombre_en354 db "Fred",0
nombre_en355 db "Susie",0
nombre_en356 db "Fabulous",0
nombre_en357 db "maid",0
;nombre_en358 db "maid",0
;nombre_en359 db "maid",0
;nombre_en360 db "king",0
;nombre_en361 db "king",0

nombre_en_array:
dw nombre_en0, nombre_en1, nombre_en2, nombre_en3, nombre_en4, nombre_en5, nombre_en6, nombre_en7, nombre_en8, nombre_en9, nombre_en10, nombre_en11, nombre_en12, nombre_en13, nombre_en13, nombre_en15, nombre_en16, nombre_en17, nombre_en17, nombre_en19, nombre_en20, nombre_en21, nombre_en22, nombre_en23, nombre_en24, nombre_en25, nombre_en26, nombre_en27, nombre_en28, nombre_en29, nombre_en30, nombre_en31, nombre_en32, nombre_en33, nombre_en34, nombre_en35, nombre_en36, nombre_en37, nombre_en37, nombre_en39, nombre_en40, nombre_en41, nombre_en42, nombre_en43, nombre_en44, nombre_en45, nombre_en45, nombre_en45, nombre_en45, nombre_en49, nombre_en49, nombre_en49, nombre_en52, nombre_en52, nombre_en52, nombre_en55, nombre_en56, nombre_en57, nombre_en57, nombre_en59, nombre_en60, nombre_en60, nombre_en60, nombre_en60, nombre_en60, nombre_en60, nombre_en66, nombre_en67, nombre_en68, nombre_en69, nombre_en70, nombre_en71, nombre_en72, nombre_en72, nombre_en72, nombre_en75, nombre_en76, nombre_en77, nombre_en78, nombre_en79, nombre_en80, nombre_en80, nombre_en82, nombre_en83, nombre_en84, nombre_en84, nombre_en84, nombre_en84, nombre_en88, nombre_en88, nombre_en88, nombre_en88, nombre_en92, nombre_en92, nombre_en92, nombre_en95, nombre_en95, nombre_en97, nombre_en98, nombre_en99, nombre_en100
dw nombre_en101, nombre_en102, nombre_en102, nombre_en102, nombre_en105, nombre_en105, nombre_en107, nombre_en108, nombre_en108, nombre_en108, nombre_en108, nombre_en112, nombre_en113, nombre_en113, nombre_en113, nombre_en113, nombre_en117, nombre_en117, nombre_en117, nombre_en120, nombre_en121, nombre_en122, nombre_en122, nombre_en124, nombre_en124, nombre_en124, nombre_en124, nombre_en124, nombre_en124, nombre_en130, nombre_en131, nombre_en132, nombre_en133, nombre_en133, nombre_en135, nombre_en136, nombre_en136, nombre_en138, nombre_en138, nombre_en140, nombre_en140, nombre_en140, nombre_en143, nombre_en143, nombre_en143, nombre_en143, nombre_en147, nombre_en148, nombre_en148, nombre_en148, nombre_en151, nombre_en152, nombre_en153, nombre_en154, nombre_en155, nombre_en156, nombre_en157, nombre_en158, nombre_en159, nombre_en160, nombre_en161, nombre_en161, nombre_en161, nombre_en164, nombre_en165, nombre_en165, nombre_en167, nombre_en168, nombre_en168, nombre_en170, nombre_en171, nombre_en171, nombre_en171, nombre_en174, nombre_en175, nombre_en176, nombre_en177, nombre_en178, nombre_en179, nombre_en180, nombre_en181, nombre_en182, nombre_en182, nombre_en184, nombre_en185, nombre_en186, nombre_en186, nombre_en188, nombre_en188, nombre_en190, nombre_en191, nombre_en191, nombre_en191, nombre_en191, nombre_en195, nombre_en196, nombre_en196, nombre_en196, nombre_en199, nombre_en200
dw nombre_en200, nombre_en202, nombre_en203, nombre_en204, nombre_en205, nombre_en206, nombre_en207, nombre_en208, nombre_en208, nombre_en208, nombre_en208, nombre_en212, nombre_en213, nombre_en214, nombre_en214, nombre_en216, nombre_en216, nombre_en216, nombre_en216, nombre_en216, nombre_en221, nombre_en222, nombre_en222, nombre_en222, nombre_en222, nombre_en226, nombre_en227, nombre_en228, nombre_en229, nombre_en230, nombre_en230, nombre_en113, nombre_en233, nombre_en234, nombre_en235, nombre_en236, nombre_en237, nombre_en238, nombre_en238, nombre_en240, nombre_en241, nombre_en242, nombre_en243, nombre_en244, nombre_en245, nombre_en246, nombre_en247, nombre_en248, nombre_en246, nombre_en250, nombre_en251, nombre_en252, nombre_en253, nombre_en253, nombre_en255, nombre_en255, nombre_en255, nombre_en258, nombre_en258, nombre_en260, nombre_en261, nombre_en261, nombre_en263, nombre_en263, nombre_en265, nombre_en265, nombre_en265, nombre_en265, nombre_en265, nombre_en270, nombre_en271, nombre_en272, nombre_en273, nombre_en274, nombre_en275, nombre_en276, nombre_en277, nombre_en278, nombre_en279, nombre_en280, nombre_en280, nombre_en282, nombre_en283, nombre_en283, nombre_en285, nombre_en285, nombre_en285, nombre_en288, nombre_en289, nombre_en290, nombre_en291, nombre_en292, nombre_en293, nombre_en293, nombre_en295, nombre_en296, nombre_en296, nombre_en298, nombre_en299, nombre_en300
dw nombre_en300, nombre_en302, nombre_en302, nombre_en302, nombre_en302, nombre_en306, nombre_en307, nombre_en307, nombre_en309, nombre_en310, nombre_en311, nombre_en312, nombre_en313, nombre_en313, nombre_en315, nombre_en315, nombre_en315, nombre_en318, nombre_en319, nombre_en320, nombre_en321, nombre_en322, nombre_en323, nombre_en324, nombre_en325, nombre_en326, nombre_en327, nombre_en328, nombre_en329, nombre_en330, nombre_en330, nombre_en332, nombre_en333, nombre_en334, nombre_en334, nombre_en336, nombre_en337, nombre_en338, nombre_en338, nombre_en340, nombre_en341, nombre_en342, nombre_en343, nombre_en344, nombre_en345, nombre_en345, nombre_en347, nombre_en347, nombre_en349, nombre_en350, nombre_en350, nombre_en352, nombre_en352, nombre_en354, nombre_en355, nombre_en356, nombre_en357, nombre_en357, nombre_en357, nombre_en124, nombre_en124
;; </NOMBRES EN INGLES>
