; This file is part of PALESTRA
;
; PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
; un TSR para traducir al castellano la aventura grafica/conversacional
; Les Manley in: Search for the King v2.0
;
; PALESTRA is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 2 of the License, or
; (at your option) any later version.
;
; PALESTRA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
;
; why PALESTRA?
; $ grep les /usr/share/dict/spanish |grep tra
; palestra

; ****************************************
; *                                      *
; *             P A R S E R              *
; *                                      *
; ****************************************

; Estructura comando:
; verbo <nombre1> <preposicion nombre2>

strcmp_cmd  proc    near
;IN:
; ES:DI -> comando introducido por usuario
; DS:SI -> palabra_es[i] (palabra=verbo|nombre|prepo)
;
;OUT:
; AX=longitud palabra (>0) si se encuentra, 0 si no se encuentra

    push    si,di,cx        ;backup
    xor cx,cx               ;inicializar longitud palabra=0
;    cld
@@loop_strcmp_cmd:  lodsb
    test al,al              ;¿palabra_es[i] == 0?
    jz @@espacio_o_null     ;si, comprobamos que despues de palabra introducida
                            ;hay un espacio o un \x00
    cmp al,byte es:[di]     ;no, comparar
    jne @@nomatch_strcmp_cmd
    inc cx                  ;match
    inc di                  ;siguiente caracter comando introducido
jmp short @@loop_strcmp_cmd
@@espacio_o_null:   cmp byte es:[di],0
    jz @@end_strcmp_cmd
    cmp byte es:[di],20h
    jz @@end_strcmp_cmd
@@nomatch_strcmp_cmd:   xor cx,cx   ;longitud palabra=0
@@end_strcmp_cmd:   xchg ax,cx      ;AX=longitud palabra
    pop cx,di,si
    ret
strcmp_cmd  endp

buscapalabra    proc    near
;IN:
; push offset array
; push numero elementos array
; call BUSCAPALABRA
;
;OUT:
; AX=0 NO HAY TRADUCCION

    push bp
    mov bp,sp

;ahora la pila es
;bp+0 => old BP
;bp+2 => @ret
;bp+4 => num. elementos array
;bp+6 => offset array

    _offset         equ [word bp+6]
    _num_elementos  equ [word bp+4]

    mov dx,_num_elementos       ;num. elementos array
    mov cx,dx
    mov bx,_offset              ;offset array
    dec bx
    dec bx
@@loop_buscapalabra:    inc bx
    inc bx                      ;siguiente cadena del array
    mov si,word [bx]            ;offset palabra_es[i]
;ES:DI -> comando introducido por usuario
;DS:SI -> palabra_es[i]
    call strcmp_cmd             ;comparamos 
    test ax,ax                  ;¿match?
loopz @@loop_buscapalabra
    inc cx                      ;no match. ¿por que inc cx? TODO: limpiar
    mov sp,bp
    pop bp
    ret 4                       ;2*(2 parametros)
buscapalabra    endp

copiapalabra    proc    near
;IN:
; push offset palabra_en_array
; push longitud palabra introducida
; call copiapalabra
;
;OUT:
; AX=longitud_palabra_traducida (palabra_en_cx)
; DX=ultimo_verbo_bx

    push bp
    mov bp,sp

;ahora la pila es
;bp+0 => old BP
;bp+2 => @ret
;bp+4 => longitud palabra introducida (palabra_es_cx)
;bp+6 => offset array

    _offset          equ [word bp+6]
    _palabra_es_cx   equ [word bp+4]

;; Traducir palabra de comando_introducido y copiarla a comando_en
    mov bx,_offset          ;offset array (offset primera palabra del array)
    sub dx,cx               ;DX = indice palabra
    shl dx,1                ;cada elemento del array ocupa 2 bytes
    add bx,dx
    mov si,word [bx]        ;ds:[si] -> palabra_en[i]
    push ds
    push di_comando_en
    push ds
    push si                 ;offset palabra_en[i] (origen)
    call strcpy
    inc ax
    add di_comando_en,ax
    mov di,di_comando_en
    mov word ds:[di-1],0020h    ;espacio + fin de cadena
    mov di,di_comando_introducido
    add di,_palabra_es_cx
    inc di
    mov di_comando_introducido,di
;;;; ¿mov di, di_comando_introducido ; lea di_comando_introducido, Word Ptr es:[di+_palabra_es_cx+1?
    mov sp,bp
    pop bp
    ret 4                   ;2*(2 parametros)
copiapalabra    endp

saltaespacios   proc    near
    dec di
@@loop_saltaespacios:
    inc di
    cmp byte es:[di],20h    ;¿es un espacio?
je @@loop_saltaespacios     ;si, seguir saltando espacios
    mov di_comando_introducido,di
    ret
saltaespacios   endp

pasapalabra proc    near
    dec di
@@bucle_pasapalabra:
    inc di
    cmp byte es:[di],0      ;¿hemos llegado a final de cadena?
    je @@end_pasapalabra    ;si, bye
    cmp byte es:[di],20h    ;¿es un espacio?
jne @@bucle_pasapalabra     ;no, seguimos saltando caracteres
@@end_pasapalabra:
;    mov di_comando_introducido, di
    ret
pasapalabra endp

escribir_palabra_tal_cual   proc    near
    push ds
    push di_comando_en              ;ds:di_comando_en -> nombre_en
    push es
    push di_comando_introducido     ;es:di_comando_introducido -> nombre introducido
    call strcpy
    ret
escribir_palabra_tal_cual   endp

tolower proc    near
; IN: ES:DI -> cadena
    push    di              ;backup
    dec di
@@loop_tolower:
    inc di                  ;siguiente caracter
    cmp byte es:[di],0      ;¿final de cadena?
    je @@exit_tolower       ;si, bye
    cmp byte es:[di],65d    ;lower bound for uppercase chars
    jb @@loop_tolower
    cmp byte es:[di],90d    ;upper bound for uppercase chars
    ja @@loop_tolower
;   and es:[di],223d        ;11011111 binary - sets uppercase
    or byte es:[di],32d     ;00100000 binary - sets lowercase
jmp short @@loop_tolower
@@exit_tolower:
    pop di
    ret
tolower endp

parser  proc    near
    push ax,bx,cx,dx,di,si,ds   ;backup
    push cs
    pop ds              ;queremos acceder a nuestras variables
    mov di,offset comando_en
    mov di_comando_en,di
    mov di,_offset_comando_introducido
    mov di_comando_introducido,di   ;por donde vamos en todo momento en comando introducido
    call tolower        ;convertir comando introducido a minusculas
; buscamos verbo_es
; comando_introducido = mirar\x00 (ejemplo)
;                       ^--ES:di_comando_introducido
;                       ^--ES:DI
    push offset verbo_es_array  ;BX = offset array
    push _verbo_array_cx        ;num. elementos array
    call buscapalabra
    test ax,ax                  ;¿hay traduccion de verbo?
    jnz @@verbo_encontrado      ;si, copiar verbo_en[i] a comando_en
    push offset verbo_en_array  ;BX = offset array
    push _verbo_array_cx        ;num. elementos array
    call buscapalabra           ;comparar verbo_en_juego con verbo_en_tsr
    test ax,ax                  ;¿match?
    jnz @@verbo_encontrado      ;si, copiar verbo_en[i] a comando_en

;;No;tenemos;verbo;en;diccionario
    dec ax                      ;AX:=-1
    mov ultimo_verbo_bx,ax
;    jmp short @@exit_parser          ; FUERA
    jmp short @@buscar_nombre

@@verbo_encontrado:
; comando_introducido = mirar\x00 (ejemplo)
;                             ^--ES:di_comando_introducido
;                             ^--ES:DI
    mov verbo_es_cx,ax          ;longitud verbo introducido
    push offset verbo_en_array
    push ax                     ;verbo_es_cx
    call copiapalabra
    mov verbo_en_cx,ax
    mov ultimo_verbo_bx,dx      ;para las descripciones con %s
                                ;indice en el array a verbo_es[i]
                                ;para acceder al contenido hacer:
                                ; lea bx,verbo_es_array
                                ; add bx,ultimo_verbo_bx
                                ; mov si,word [bx]
                                ;y entonces...
                                ; DS:[BX] -> verbo_es[i]
                                ;o para acceder en ingles:
                                ; lea bx,verbo_en_array
                                ; add bx,ultimo_verbo_bx
                                ; mov si,word [bx]
                                ;y entonces...
                                ; DS:[BX] -> verbo_en[i]
;;;;    push bx,si ; backup
;;;;    lea bx, verbo_en_array
;;;;    add bx, dx      ; dx=ultimo_verbo_bx
;;;;    mov si, Word Ptr [bx]
;;;;    ; DS:[si] -> verbo_en[i]
;;;;    push ds
;;;;    push offset ULTIMO_VERBO_EN_INTRODUCIDO
;;;;    push ds
;;;;    push si
;;;;    call STRCPY
;;;;    pop si,bx

; mirar escritorio
;       ^---ES:DI
    cmp byte es:[di-1],0                ;¿se ha introducido solo verbo?
    jne @@buscar_nombre                 ;no, buscar nombre
;    jmp short @@escribir_comando_en_memoria
    push es                             ;si, no añadimos nada al verbo
    push _offset_comando_introducido    ;offset comando introducido por usuario
    push ds
    push offset comando_en              ;comando traducido por el parser
    call strcpy
    mov di,_offset_comando_introducido
    add di,verbo_en_cx
    mov byte es:[di-1],0    ;sustituir espacio que hay tras verbo_en por \x00
;previene "mirar bufanda" + "tocar guitarra" (sin tenerla) = "no veo bufanda aqui."
    xor ax,ax
    dec ax                      ;AX==-1
    mov ultimo_nombre_bx,ax         
    mov ultimo_nombre2_bx,ax
    jmp @@exit_parser
@@buscar_nombre:    call saltaespacios
; mirar escritorio
;       ^---ES:DI
    push offset nombre_es_array ;BX = offset array
    push _nombre_array_cx       ;num. elementos array
    call buscapalabra
    test ax,ax                  ;¿tenemos traduccion de nombre?
    jnz @@nombre_encontrado     ;si, copiar nombre_en a comando_en
    push offset nombre_en_array ;BX = offset array
    push _nombre_array_cx       ;num. elementos array
    call buscapalabra           ;comparar nombre_en_juego con nombre_en_tsr
    test ax,ax                  ;¿match?
    jnz @@nombre_encontrado     ;si, copiar nombre_en[i] a comando_en
; No tenemos nombre en diccionario.
    dec ax                      ;AX==-1
    mov ultimo_nombre_bx,ax
; Intentamos saltar espacios hasta siguiente palabra
    call pasapalabra
    cmp byte es:[di],0          ;¿hemos llegado a final de cadena?
    jne @@buscar_nombre         ;no, buscar nombre en siguiente palabra
; No tenemos traduccion de nombre. Escribir tal cual se ha introducido
    call escribir_palabra_tal_cual
    jmp @@escribir_comando_en_memoria

@@nombre_encontrado:
    mov nombre_es_cx,ax         ;longitud nombre introducido
;; Traducir nombre de comando introducido y copiarlo al comando que pondremos en memoria
    push offset nombre_en_array
    push ax                     ;nombre_es_cx
    call copiapalabra
    mov nombre_en_cx,ax
    mov ultimo_nombre_bx,dx
; comando_en = look\x20\desk\x20\x00 (ejemplo)
;                                 ^--DS:di_comando_en
;; Buscamos preposiciones
    cmp byte es:[di-1],0        ;¿se ha introducido solo nombre1?
    jne @@buscar_prepo          ;no, buscar prepo
    jmp short @@escribir_comando_en_memoria     ;si, no añadimos nada a nombre1

@@buscar_prepo: call SALTAESPACIOS
; mirar escritorio con lupa
;                  ^---ES:DI
    push offset prepo_es_array  ;BX = offset array
    push _prepo_array_cx        ;num. elementos array
    call buscapalabra
    test ax,ax                  ;¿tenemos traduccion de prepo?
    jnz @@prepo_encontrada      ;si, copiar prepo_en a comando_en
    push offset prepo_en_array  ;BX = offset array
    push _prepo_array_cx        ;num. elementos array
    call buscapalabra           ;comparar prepo_en_juego con prepo_en_tsr
    test ax,ax                  ;¿match?
    jnz @@prepo_encontrada      ;si, copiar prepo_en[i] a comando_en
; No tenemos prepo en diccionario.
; Intentamos saltar espacios hasta siguiente palabra
    call pasapalabra
    cmp byte es:[di],0          ;¿hemos llegado a final de cadena?
    jne @@buscar_prepo          ;no, buscar prepo en siguiente palabra
; No tenemos traduccion de prepo. Escribimos lo que tenemos traducido
;    call ESCRIBIR_PALABRA_TAL_CUAL
;previene "mirar bufanda" + "tocar guitarra" (sin tenerla) = "no veo bufanda aqui."
    xor ax,ax
    dec ax                      ;AX:=-1
    mov ultimo_nombre2_bx,ax
    jmp short @@escribir_comando_en_memoria

@@prepo_encontrada:
    mov prepo_es_cx,ax          ;longitud prepo introducida
;; Traducir prepo de comando introducido y copiarla al comando que pondremos en memoria
    push offset prepo_en_array
    push ax                     ;prepo_es_cx
    call copiapalabra
    mov prepo_en_cx,ax
; comando_en = look\x20\desktop\x20\with\x20\x00 (ejemplo)
; ¿o es comando_en = look\x20\desktop\with\x00 (ejemplo) ? COMPROBAR
;; Buscamos nombre2
@@buscar_nombre2:   call saltaespacios
; mirar escritorio con lupa
;                      ^---ES:DI
    push offset nombre_es_array ;BX = offset array
    push _nombre_array_cx       ;num. elementos array
    call buscapalabra
    test ax,ax                  ;¿tenemos traduccion de nombre2?
    jnz @@nombre2_encontrado    ;si, copiar nombre2_en a comando_en
    push offset nombre_en_array ;BX = offset array
    push _nombre_array_cx       ;num. del array
    call buscapalabra           ;comparar nombre2_en_juego con nombre2_en_tsr
    test ax,ax                  ;¿match?
    jnz @@nombre2_encontrado    ;si, copiar nombre2_en[i] a comando_en
; No tenemos nombre2 en diccionario.
    dec ax                      ;AX:=-1
    mov ultimo_nombre2_bx,ax
; Intentamos saltar espacios hasta siguiente palabra
    call pasapalabra
    cmp byte es:[di],0          ;¿hemos llegado a final de cadena?
    jne @@buscar_nombre2        ;no, buscar nombre en siguiente palabra
; No tenemos traduccion de nombre2. Escribir tal cual se ha introducido
    call escribir_palabra_tal_cual
    jmp short @@escribir_comando_en_memoria
@@nombre2_encontrado:
;; Traducir nombre de comando introducido y copiarlo al comando que pondremos en memoria
    mov nombre2_es_cx,ax        ;longitud nombre2 introducido
;; Traducir nombre2 de comando introducido y copiarlo al comando que pondremos en memoria
    push offset nombre_en_array
    push ax                     ;nombre_es_cx
    call copiapalabra
    mov nombre2_en_cx,ax
    mov ultimo_nombre2_bx, dx
; comando_en = look\x20\desktop\x20\with\x20\x00 (ejemplo)
; ¿o es comando_en = look\x20\desktop\with\x00 (ejemplo) ? COMPROBAR
@@escribir_comando_en_memoria:  push es
    push _offset_comando_introducido    ;offset comando introducido por usuario
    push ds
    push offset comando_en              ;comando traducido por parser
    call strcpy
@@exit_parser:  pop ds,si,di,dx,cx,bx,ax    ;restore
    ret
parser  endp
