; This file is part of PALESTRA
;
; PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
; un TSR para traducir al castellano la aventura grafica/conversacional
; Les Manley in: Search for the King v2.0
;
; PALESTRA is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 2 of the License, or
; (at your option) any later version.
;
; PALESTRA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
;
; why PALESTRA?
; $ grep les /usr/share/dict/spanish |grep tra
; palestra

; ****************************************
; *                                      *
; *      R U T I N A S     I S R         *
; *                                      *
; ****************************************

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ISR para interceptar el teclado
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
newint9 proc far
    push	ax,si,ds
    push 40h                ;BIOS_DataSegment
    pop ds
    mov	si,[001Ch]          ;BIOS_KeyboardBufferTailPointer
    pushf
    call far cs:[oldint9]   ;dejar que la BIOS se encargue del hardware
    cmp	si,[001Ch]          ;BIOS_KeyboardBufferTailPointer
    je @@fin9               ;no hay nueva tecla en buffer
    mov	al,[si+1]           ;SCAN (ASCII en [si])
    cmp al,27h              ;SCAN ñ
    jne @@no_enye
    mov byte [si],'>'       ;patch ASCII!
    jmp short @@fin9
@@no_enye:  cmp al,1ch      ;SCAN intro
    jne @@fin9
    push    es
    mov es,word ss:[0a298h] ;gracias debugger (es:[1eah] -> comando introducido)
    cmp byte es:[_offset_comando_introducido],0     ;¿hay comando en es:1eah?
    jz @@comando_vacio                  ;no, nos vamos sin llamar al parser
;**11. bug: nombre partida guardada: se queda solo con la primera palabra, independientemente de las palabras que escribamos (probablemente el parser este sustituyendo el primer espacio por \x00).
;si no una partida que intentemos guardar como "hola mundo que tal", se quedara como "hola", o quizas "tal".
;TODO!! si es intro, no llamar al parser si estamos en los menus. Pensar si hay mas casos a eliminar.
;TODO!! convertir a mayusculas ¿TODO?
    call parser
@@comando_vacio:    pop es  ;restore
@@fin9: pop ds,si,ax
    iret
newint9 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ISR_60, traduce:
;;   -descripciones.
;;   -titulos de ventanas.
;; UMBDATA.ASM: cadenas a matchear
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
newint60 proc far
    mov di,dx       ;la instruccion que hemos parcheado con CD 60 en EXE.EXE
                    ;tiene que ser la primera
    push es,ds,bx,cx,di,si,dx,ax    ;backup

;;las dos instrucciones que siguen, puede que se puedan comentar, creo que
;con la que tiene que ser la primera instruccion (mov di,dx), ya tenemos en
;es:di y dx lo que queremos. TODO! comprobar
;TODO! tb intentar hacer todo lo que se pueda con DS y no ES, ya que ocupara
;menos bytes. En este caso intentar "lds dx,[bp+06] ; mov si,dx" y a partir de
;ahi trabajar con DS:SI en vez de ES:DI.
    les dx,[bp+06]  ;esto es lo que el propio juego hace para obtener es:dx
    mov di,dx       ;es:di ->desc_juego
;;
;;si no hay nada que hacer, bye
    cmp byte es:[di],20h    ;¿printable ascii?
    jb @@exit60
    cmp byte es:[di],7eh    ;¿printable ascii?
    ja @@exit60
    push es
    pop ax
    dec ax
    mov ds,ax       ;ds=es-1    ;¿habra alguna forma mejor de hacerlo? COMPROBAR
;;;aqui podria haber excepciones a admitir antes del je @@exit60b, COMPROBAR
    cmp word es:[di+10h],005ah
    je @@exit60
    cmp word es:[di+20h],005ah
    je @@exit60
;;;aqui podria haber excepciones a admitir antes del je @@exit60b, COMPROBAR
    cmp word es:[di+10h],004dh
    je @@exit60
    cmp word es:[di+20h],004dh
    je @@exit60    ;esto evita cuelgue de Bobbi
;("verter soda en bufanda", Bobbi nos echa, y al ir a la derecha, se colgaba.)
;;;aqui podria haber excepciones a bloquear antes del je @@procesar60, COMPROBAR
;    cmp byte ds:[di+0fh],0    ;inventario + mirar en cajon
;    jnz @@exit60
;    cmp word ds:[di+0dh],0    ;esto bloqueaba algunos objetos de inventario ultima pantalla
;    jnz @@exit60
    cmp word ds:[di+0eh],0     ;inventario + mirar en cajon
    jnz @@exit60
    cmp byte ds:[di],4dh
    je @@procesar60
;;inventario
;;;aqui podria haber excepciones a bloquear antes del je @@procesar60, COMPROBAR
    cmp byte ds:[di+3],0c7h    ;inventario + mirar en cajon
    je @@procesar60
    cmp byte ds:[di+3],0c6h    ;mirar (...There's rosin here)
    je @@procesar60
   
;;titulos
;    cmp byte ds:[di+0fh],0    ;ya comprobado mas arriba
;    jnz @@exit60
;;<comentado 20210406>
;; fix: cargar/reiniciar partida + "mirar tarro" -> "A jar."
;; OJO!! si hay cuelgues o alguna regresion: descomentar.
;    cmp byte es:[di+4fh],0
;    jnz @@exit60
;;</comentado 20210406>
    cmp di,1eah                 ;¿es un comando?
    jne @@procesar60            ;no, procesar
    call fixes                  ;si, mirar si procede aplicar algun fix
    jmp short @@exit60
@@procesar60:   call procesar60
@@exit60:   pop ax,dx,si,di,cx,bx,ds,es     ;restore
    iret                ;volver al juego
newint60 endp

procesar60 proc near
    push cs
;    cmp word es:[di+2eh], 0ab6ah
;    jne @@procesar60b
;    cmp ultimo_nombre_bx,0      ;¿parser guardó indice ultimo nombre introducido?
;    jge @@exit62                ;si, fuera
; solo tratamos de buscar el nombre si parser no lo encontro (ultimo_nombre_bx == -1)
;; guardar en una variable ULTIMO_NOMBRE_EN_INTRODUCIDO
;; (la cadena en la posicion ES:DI)
;    push    si
;    lea si, ULTIMO_NOMBRE_EN_INTRODUCIDO
;    push ds
;    push si
;    push es
;    push di         ; ES:[di] -> ULTIMO_(verbo|nombre|nombre2)_EN_INTRODUCIDO
;    call STRCPY
;    pop di
;@@procesar60b:  push cs
    pop ds
    mov cx,_desc60_umb_array_cx     ;num. elementos array
    xor bx,bx                       ;comenzar en offset=0
    push Word Ptr [umb_seg]
    pop ds
    dec bx
    dec bx
@@loop60: inc bx            ;no match
    inc bx                  ;siguiente desc_tsr_en
    mov si,_desc60_umb_en_array_offset[bx]
    mov di,dx
    call faster_strcmp
    test ax,ax              ;¿match?
loopnz @@loop60
    test ax,ax              ;la ultima cadena podria ser un match
    jnz @@exit_procesar60   ;no match, bye
;ds:si ->desc_tsr_en
    mov si,_desc60_umb_es_array_offset[bx]      ;match
    mov di,dx
;ds:si ->desc_tsr_es
    push es             ;desc_juego (umb_seg)
    push dx             ;desc_juego
    push ds             ;desc_tsr_es
    push si             ;desc_tsr_es
    call strcpy
@@exit_procesar60:  ret
procesar60 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ISR_61, traduce:
;;   -descripciones.
;; EMSDATA.ASM: cadenas a matchear
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
newint61 proc far
;ds:0 ->desc_juego
    mov di,si   ;la instruccion que hemos parcheado con CD 61 en EXE.EXE
                ;tiene que ser la primera
    push    es,ds,bx,cx,di,si,dx,ax     ;backup
;;si no hay nada que hacer, bye
    cmp byte ds:[0],20h         ;¿printable ascii?
    jb @@exit61
    cmp byte ds:[0],7eh         ;¿printable ascii?
    ja @@exit61
;    cmp byte ds:[0],0
;    je @@exit61
    cmp word ds:[29h],4558h     ;XE
    je @@exit61
;    cmp byte ds:[0],99h
;    je EXIT61
;;</CONTROL PARA SALIR SI NO HAY NADA PARA HACER>

    call procesar61
@@exit61:   pop ax,dx,si,di,cx,bx,ds,es ;restore
    iret                        ;volver al juego
newint61    endp

procesar61  proc    near
    push ds
    pop es
    xor dx,dx                   ;es:dx ->desc_juego
    push cs
    pop ds
    mov cx,_desc61_ems_array_cx ;num. elementos array
    push Word Ptr [ems_seg]
    pop ds
    mov di,_desc61_ems_en_array_offset
    mov bx,-2                   ;comenzaremos en offset=0
@@loop61:
    inc bx                      ;no match
    inc bx                      ;siguiente desc_tsr_en
    mov si,[di+bx]
    push es                     ;desc_juego
    push dx                     ;desc_juego
    push ds                     ;desc_tsr_en (ems_seg)
    push si                     ;desc_tsr_en
    call strcmp_plus
    test ax,ax                  ;¿match?
loopz @@loop61
    test ax,ax                  ;la ultima cadena podria ser un match
    jz @@subcadena61            ;no match, comprobar subcadenas
;ds:si ->desc_tsr_en
    mov di,_desc61_ems_es_array_offset      ;match, escribir en memoria
    mov si,[di+bx]              ;traducir desc_tsr
;ds:si ->desc_tsr_es
    push es                     ;desc_juego
    push dx                     ;desc_juego
    push ds                     ;desc_tsr_es (ems_seg)
    push si                     ;desc_tsr_es
    call strcpy_plus
    jmp short @@exit_procesar61
@@subcadena61:  mov cx,_subcadena61_ems_array_cx    ;num. elementos array
    xor bx,bx                                       ;comenzar en offset=0
    mov di,_subcadena61_ems_en_array_offset
@@loop_subcadena61:
    mov si,[di+bx]
; IN:
;     push offset cadena donde buscamos la subcadena (haystack)
;     push offset subcadena buscada (needle)
;     call strstr
    push dx     ;es:dx ->subcadena_juego
    push si     ;ds:si ->subcadena_tsr_es
    call strstr
; OUT:
;     AX - indice subcadena o -1 si no se encuentra
    cmp ax,-1               ;¿match?
    jne @@escribir_subcadena61_en_memoria
    inc bx                  ;no match
    inc bx                  ;siguiente desc_tsr_es
loop @@loop_subcadena61     ;¿quedan desc_tsr_es por comprobar?
;;    call segunda_vuelta
    jmp short @@exit_procesar61      ;no, bye
@@escribir_subcadena61_en_memoria:
;ds:si ->subcadena_tsr_en
    mov di,_subcadena61_ems_es_array_offset
    mov si,[di+bx]          ;traducir subcadena_tsr
;ds:si ->subcadena_tsr_es
    add ax,dx
    push es
    push ax                 ;es:ax ->subcadena_juego
    push ds
    push si                 ;ds:si ->subcadena_tsr_es
    call strcpy
@@exit_procesar61:  ret
procesar61 endp

;;;;<comentado 20210410, esta rutina nunca se llama>
;;;; segunda_vuelta proc near
;;;;    push cs
;;;;    pop ds
;;;;    mov cx,_desc60_umb_array_cx     ;num. elementos array
;;;;    xor bx,bx                       ;comenzar en offset=0
;;;;    push Word Ptr [umb_seg]
;;;;    pop ds
;;;;    dec bx
;;;;    dec bx
;;;;@@loop60b: inc bx        ;no match
;;;;    inc bx              ;siguiente desc_tsr_en
;;;;    mov si,_desc60_umb_en_array_offset[bx]
;;;;    dejar comentado ->;    mov di,dx
; IN:
;     push offset cadena donde buscamos la subcadena (haystack)
;     push offset subcadena buscada (needle)
;     call strstr
;;;;        push dx     ;es:dx ->subcadena_juego
;;;;        push si     ;ds:si ->subcadena_tsr_es
;;;;        call strstr
; OUT: 
;     AX - indice subcadena o -1 si no se encuentra
;;;;        cmp ax,-1
;;;;        jne @@escribir_segunda_vuelta_60_en_memoria
;;;;    loop @@loop60b
;;;;        cmp ax,-1       ;la ultima cadena podria ser un match
;;;;        je @@exit_segunda_vuelta     ;no match, bye
;;;;    @@escribir_segunda_vuelta_60_en_memoria:
;ds:si ->desc_tsr_en
;;;;        mov si,_desc60_umb_es_array_offset[bx]      ;match
;;;;        mov di,dx
;ds:si ->desc_tsr_es
;;;;        add ax,dx
;;;;        push es             ;desc_juego (umb_seg)
;;;;        push ax             ;desc_juego
;;;;        push ds             ;desc_tsr_es
;;;;        push si             ;desc_tsr_es
;;;;        call strcpy
;;;;    @@exit_segunda_vuelta:    ret
;;;;    segunda_vuelta endp
;;;;</comentado 20210410, esta rutina nunca se llama>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;en Habitacion hotel te puedes sentar en una cama.
;;se cuelga con el comando SIT a secas.
;;funciona con el comando SIT BED
;;es un bug del juego (v2.0), sin TSR tambien ocurre.
;;
;;fix:
;;¿estamos en la habitacion del hotel y se ha introducido "sit"?
;;si, sustituir "sit\x00" por "sit\x20bed\x00" (mov es:[di+2],\x20bed\x00)
;;no, bye
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
fixes proc near
    push    ds,si,di,dx,cx          ;¿push ds es necesario?
    push cs                         ;¿necesario?
    pop ds                          ;¿necesario?
;;fix: "dejar pala" sin tenerla en habitacion Elefantes cuelga el juego
    mov dx,di                       ;guardar valor original de di
    mov di,29eah                    ;room_juego
    mov si,offset str_room1         ;"Elefantes\x00"
    call faster_strcmp              ;¿match?
    jnz @@chk_bug_sit_down          ;no match
    mov di,dx                       ;match, restore di
    mov si,offset str_cmd1          ;"drop shovel\x00"
    call faster_strcmp              ;¿match?
    jnz @@chk_bug_sit_down          ;no match
    mov di,dx                       ;match,restore di
    mov si,offset str_cmd1_fixed    ;"leave shovel\x00"
    mov cx,13d                      ;longitud ds:[si]
    rep movsb                       ;patch! write to memory "leave shovel\x00"
    jmp short @@exit_fixes          ;all done
;;fix: "sit" en Habitacion hotel
;es:29ea 48 61 62 69 74 61 63 69 2F 6E 00 00 00 00 00 00  Habitaci/n
@@chk_bug_sit_down: push es
    pop ds
    cmp byte ds:[29f2h],2fh         ;¿estamos en habitacion del hotel?
    jne @@exit_fixes
    mov si,dx                       ;si:=original di
;ds:si -> 73 69 74 20 62 65 64 00
;         s  i  t  20 b  e  d  0
    cmp word ds:[si],6973h          ;¿se ha introducido "sit" a secas?
    jne @@exit_fixes
    cmp word ds:[si+2],0074h        ;¿se ha introducido "sit" a secas?
    jne @@exit_fixes
    mov word ds:[si+3],6220h        ;patch!
    mov word ds:[si+5],6465h
    mov byte ds:[si+7],0
@@exit_fixes:   pop cx,dx,di,si,ds     ;¿ds es necesario?
    ret
fixes endp
