; This file is part of PALESTRA
;
; PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
; un TSR para traducir al castellano la aventura grafica/conversacional
; Les Manley in: Search for the King v2.0
;
; PALESTRA is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 2 of the License, or
; (at your option) any later version.
;
; PALESTRA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
;
; why PALESTRA?
; $ grep les /usr/share/dict/spanish |grep tra
; palestra

; ****************************************
; *                                      *
; *   I N S T A L A C I O N     T S R    *
; *                                      *
; ****************************************

@@initcode:
;el codigo residente en memoria acaba aqui
    call chkresidente
    test ax,ax                  ;¿estamos ya residentes?
    jz @@exit_DOS_no_resident   ;SI: exit to DOS, sin quedarnos residentes
                                ;NO: TSR :)
    call UMB

;;EMS;Driver;Check;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ax,3567h                ;get @int67
	int 21h
	mov di,0ch                  ;offset de 'EMMXXXX'
	cmp word es:[di],'XM'       ;check for 'MX' id
	jne @@exit_DOS_no_resident  ;not found, exit to DOS
	
;;Allocate;EMS;Memory;and;Map;Page;0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ah,41h                  ;get Pageframe Start
	int 67h
	push bx                     ;save the Page 0 address
	mov word ems_seg,bx
	mov ah,42h                  ;check available Pages
	int 67h
	test ah,ah                  ;check return code
	jnz @@exit_DOS_no_resident  ;exit to DOS on error
    cmp bx,4                    ;check if pages >= 4
    jb	@@exit_DOS_no_resident  ;if <4 then exit to DOS
  	mov bx,4                    ;four 16k Pages
	mov ah,43h                  ;allocate Pages
	int 67h
	;DX = EMM handle
	test ah,ah                  ;check return code
	jnz @@exit_DOS_no_resident  ;exit to DOS on error
	xor bx,bx                   ;map 1 page to phisical page 0
	mov ax,4400h                ;map Page
	int 67h
    test ah,ah                  ;¿hubo algun error?
	jnz @@exit_DOS_no_resident  ;si, salir al DOS
    mov ax,4401h                ;map memory
    inc bx
    int 67h
    test ah,ah                  ;¿hubo algun error?
	jnz @@exit_DOS_no_resident  ;si, salir al DOS
    mov ax,4402h                ;map memory
    inc bx
    int 67h
    test ah,ah                  ;¿hubo algun error?
	jnz @@exit_DOS_no_resident  ;si, salir al DOS
    mov ax,4403h                ;map memory
    inc bx
    int 67h
    test ah,ah                  ;¿hubo algun error?
	jnz @@exit_DOS_no_resident  ;si, salir al DOS
;    mov ah,41h                 ;get page frame address
;    int 67h
;    or ah,ah                   ;¿hubo algun error?
;    jnz @@exit_DOS_no_resident ;si, salir al DOS
;    mov es,bx                  ;make page frame addressable
	pop es                      ;set Pageframe address
    call MapEMS
	jmp short @@ISR_install

@@exit_DOS_no_resident:
    mov dx,offset msg_yaresidente
    mov ah,9                ;print string
    int 21h
    mov ah,4ch              ;terminate process with return code
    int 21h

@@ISR_install:
    mov dx,offset msg_welcome
    mov ah,9                ;print string
    int 21h
    xor ah,ah
    int 16h
    mov ax,3509h            ;get @int9
    int 21h
    mov OLDINT9[0],bx       ;offset INT_9_BIOS
    mov OLDINT9[2],es       ;segment INT_9_BIOS
    mov ah,25h              ;set @int9, OJO! asegurate de que AL=09h
    mov dx,offset NEWINT9
    int 21h
    mov al,60h              ;set @int60
    mov dx,offset NEWINT60
    int 21h
    mov al,61h              ;set @int61
    mov dx,offset NEWINT61
    int 21h
    mov es,ds:[2ch]         ;@entorno
    mov ah,49h              ;liberar espacio entorno
    int 21h
    push ds
    pop es
    mov dx,offset @@initcode    ;fin codigo residente
    add dx,0fh              ;redondeo a parrafo
    mov cl,4
    shr dx,cl               ;bytes->parrafos
    mov ax,3100h            ;TSR
    int 21h

UMB proc near
    call inic_XMS           ;detectar controlador XMS
    mov ax,_umb_paras       ;area residente
    call UMB_alloc          ;pedir memoria superior XMS
    jnc @@instalar_umb      ;hay la suficiente
    mov ax,_umb_paras
    call UPPER_alloc        ;pedir memoria superior DOS 5
    jc @@exit_umb           ;no hay la suficiente
    stc                     ;indicar que usa memoria DOS
@@instalar_umb:
    mov umb_seg,ax          ;segmento del bloque UMB
;;Copy;Virus;to;PageFrame;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    push    es              ;backup
	mov es,ax
	xor di,di
;<volcar todos los bytes de UMBDATA.BIN en umb_seg:0>
    mov ax,3d00h            ;open file read-only
;DS:DX = pointer to an ASCIIZ file name
    mov dx,offset umbfile
    int 21h                 ;INT 21/3d
    mov bx,ax               ;BX=file handle
    mov ah,3fh
    mov cx,_umb_size        ;num_bytes_to_read
;DS:DX = pointer to read buffer
    xor dx,dx               ;offset 0
    push    ds              ;backup
    push Word Ptr [umb_seg]
    pop ds                  ;DS=umb_seg
    int 21h                 ;INT 21/3f
    pop ds                  ;restore
    mov ah,3eh              ;close file using handle
    int 21h
    pop es                  ;restore
;</volcar todos los bytes de UMBDATA.BIN en umb_seg:0>
@@exit_umb: ret
UMB endp

MapEMS proc near
;;Copy;Virus;to;PageFrame;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	xor di,di
;	lea si,desc61_ems1 ;Set Si to source
;<volcar todos los bytes de EMSDATA.BIN en E000:0>
    mov ax,3d00h            ;open file read-only
;DS:DX = pointer to an ASCIIZ file name
    mov dx,offset emsfile
    int 21h                 ;INT 21/3d
    mov bx,ax               ;BX=file handle
    mov ah,3fh
    mov cx,_ems_size        ;num_bytes_to_read
;DS:DX = pointer to read buffer
    xor dx,dx               ;offset 0
    push    ds              ;backup
    push Word Ptr [ems_seg]
    pop ds                  ;DS=ems_seg
    int 21h                 ;INT 21/3f
    pop ds                  ;restore
;	mov cx,_ems_size/2 ;Set Cs to size of EMS bin file in words
;	rep movsw ;Copy Virus to memory
    mov ah,3eh              ;close file using handle
    int 21h
;</volcar todos los bytes de EMSDATA.BIN en E000:0>
    ret
MapEMS endp

chkresidente    proc    near
;OUT: 
; AX=0 -> RESIDENTE
; AX=1 -> NO RESIDENTE
    mov ax,3561h                ;get @int61
    int 21h                     ;puntero en es:[bx]
    xor ax,ax                   ;inicializamos ax=0 (residente)
    cmp word es:[bx],0f789h     ;¿primeros opcodes int61 == 89 F7? (mov si,di)
    je @@residente              ;SI: nos vamos con AX=0 (residente)
    inc ax                      ;NO: AX:=1
@@residente:
    ret
chkresidente endp

; ------------ Considerar presencia de controlador XMS
inic_XMS    proc
    mov ax,4300h
    int 2fh                 ;¿hay XMS?
    cmp al,80h
    jne XMS_ausente         ;no instalado
    push es
    mov ax,4310h
    int 2fh                 ;SI: obtener su direccion
    mov word XMS_off,bx     ;y preservarla
    mov word XMS_seg,es
    mov byte xms_ins,1
    pop es
    ret
XMS_ausente: mov byte xms_ins,0
    ret
inic_XMS    endp

gestor_XMS LABEL DWORD  ;@controlador XMS
XMS_off dw 0
XMS_seg dw 0

; ------------ Reservar bloque de memoria superior del nº parrafos AX,
;              devolviendo en AX el segmento donde esta. CF=1 si no
;              esta instalado el gestor XMS (AX=0) o hay un error (AL
;              devuelve el codigo de error del controlador XMS).
UMB_alloc   proc
    push bx,cx,dx
    cmp byte xms_ins,1
    jne no_umb_disp         ;no hay controlador XMS
    mov dx,ax               ;numero de parrafos
    mov ah,10h              ;solicitar memoria superior
    call gestor_XMS
    cmp ax,1                ;¿ha ido todo bien?
    mov ax,bx               ;segmento UMB/codigo de error
    jne XMS_fallo           ;fallo
    pop dx,cx,bx            ;ok
    clc
    ret
no_umb_disp:    xor ax,ax
XMS_fallo:      pop dx,cx,bx
                stc
                ret
UMB_alloc   endp

; ------------ Reservar memoria superior, con DOS 5.0, del tamaño
;              solicitado (AX parrafos). Si no hay bastante CF=1,
;              en caso contrario devuelve el segmento en AX.
UPPER_alloc proc
    push ax
    mov ah,30h
    int 21h
    cmp al,5
    pop ax
    jae UPPER_existe
    stc
    jmp short UPPER_fin             ;necesario DOS 5.0 minimo
UPPER_existe:  push ax              ;backup parrafos...
               mov ax,5800h
               int 21h
               mov alloc_strat,ax   ;backup estrategia
               mov ax,5802h
               int 21h
               mov umb_state,al     ;backup estado UMB
               mov ax,5803h
               mov bx,1
               int 21h              ;conectar cadena UMB's
               mov ax,5801h
               mov bx,41h
               int 21h              ;High Memory best fit
               pop bx               ;...parrafos requeridos
               mov ah,48h
               int 21h              ;asignar memoria
               pushf
               push ax              ;guardado el resultado
               mov ax,5801h
               mov bx,alloc_strat
               int 21h              ;restore estrategia
               mov ax,5803h
               mov bl,umb_state
               xor bh,bh
               int 21h              ;restore estado cadena UMB
               pop ax
               popf
               jc UPPER_fin         ;hubo fallo
               push ds
               dec ax
               mov ds,ax
               inc ax
               mov word ds:[1],ax       ;manipular PID
               mov word ds:[16],20cdh   ;simular PSP
               push es
               mov cx,ds
               mov es,cx
               mov cx,cs
               dec cx
               mov ds,cx
               mov cx,8
               mov si,cx
               mov di,cx
               cld
               rep movsb            ;copiar nombre de programa
               pop es,ds
               clc
UPPER_fin:     ret
UPPER_alloc endp

; ***********************************************
; *                                             *
; *   D A T O S    N O    R E S I D E N T E S   *
; *                                             *
; ***********************************************

xms_ins db 0                            ;a 1 si presente controlador XMS
alloc_strat dw 0                        ;estrategia asignacion (DOS 5)
umb_state db 0                          ;estado de bloques UMB (DOS 5)
emsfile db "EMSDATA.BIN",0
umbfile db "UMBDATA.BIN",0
_offset_comando_introducido equ 490d    ;1eah (cmd comienza en es:1eah)
msg_yaresidente db "PALESTRA dice: ya estoy en memoria, nothing todo. bye",0dh,0ah,"$"
;msg_welcome db "|=-----------------------------------------------------------------------=|",0dh,0ah
msg_welcome db "|=--------------=[             palestra v0.1             ]=--------------=|",0dh,0ah
db "|=-----------------------------------------------------------------------=|",0dh,0ah
db "|=---------------=[ un TSR para traducir al castellano ]=----------------=|",0dh,0ah
db "|=---------------=[ Les Manley in: Search for the King ]=----------------=|",0dh,0ah
db "|=-----------------------------------------------------------------------=|",0dh,0ah
db "|=--------------------=[ pakolmo ]=--=[ traduccion ]=--------------------=|",0dh,0ah
db "|=-------------------=[ https://pakolmo.netlify.app ]=-------------------=|",0dh,0ah
db "|=-----------------------------------------------------------------------=|",0dh,0ah
db "|=------------------=[ danstructor ]=--=[ traduccion ]=------------------=|",0dh,0ah
db "|=-----------------------------------------------------------------------=|",0dh,0ah
db "|=----------------------=[ gatuno ]=--=[ codigo ]=-----------------------=|",0dh,0ah
db "|=----------------------=[ https://www.vlan7.org ]=----------------------=|",0dh,0ah,0dh,0ah
;db "|=-----------------------------------------------------------------------=|",0dh,0ah,0dh,0ah
db "  PALESTRA is free software: you can redistribute it and/or modify",0dh,0ah
db "it under the terms of the GNU General Public License as published by",0dh,0ah
db "the Free Software Foundation, GPL-2.0-or-later.",0dh,0ah
db "  PALESTRA is distributed in the hope that it will be useful,",0dh,0ah
db "but WITHOUT ANY WARRANTY; without even the implied warranty of",0dh,0ah
db "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",0dh,0ah
db "GNU General Public License for more details.",0dh,0ah
db "  You should have received a copy of the GNU General Public License",0dh,0ah
db "along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.",0dh,0ah,0dh,0ah
db "PALESTRA dice: me encanta que los planes salgan bien, estoy residente. :)",0dh,0ah,"$"

tsr     ends

    end @@start
