# This file is part of PALESTRA
#
# PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
# un TSR para traducir al castellano la aventura grafica/conversacional
# Les Manley in: Search for the King v2.0
#
# PALESTRA is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# PALESTRA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
#
# why PALESTRA?
# $ grep les /usr/share/dict/spanish |grep tra
# palestra

#!/bin/bash

function core {
# $1: cadena
# $2: archivo

    line="$(grep "^$1" "$2" |grep -v "^$1_array" |tail -n 1)"
    str="$(echo "$line" |cut -d\" -f2)"
    lenght1=$(echo "$str" |wc -c)    # longitud $str  # echo hola |wc -c  --devuelve-> 5 (nos va bien porque queremos contar el \x00 de fin de cadena)

    lenght2=$(echo "$line" |egrep -owe '([0-9]h)|([0-9][0-9]h)' |wc -l)     # edge_case1, por ejemplo si $line es:
                                                                            # subcadena61_ems_es22 db "Lo siento, cari}o, no me quedan.",22h,"",0
                                                                            # lenght2 valdra 1, porque hay un 22h
                                                                            # TODO: Si $line es
                                                                            # subcadena61_ems_es22 db "",22h,"No Molestar, por favor.",22h,"",0
                                                                            # Lo hace MAL, Probablemente sea porque la cadena incluye el caracter 22h (comillas dobles) en una posicion distinta del final, y parece que el script no lo pilla bien. Solucionar.

    lenght=$(($lenght1 + $lenght2))
    start=$(grep -Fboa "$str" <"$3" |cut -d: -f1)   # posicion en bytes donde comienza la cadena (en todo el archivo)
    suma=$(($start + $lenght))
#    printf "#line#$line#str#$str#lenght1#$lenght1#lenght2#$lenght2#lenght#$lenght#start#$start#suma#%x#\n" $suma    #hexa
    echo "$line" |egrep -owe '([0-9]h)|([0-9][0-9]h)'   #debug edge_case1
#    printf "$2: $1_array comienza en %x\n" $suma    #hexa
    printf "_$1_array_offset equ 0%xh ; (segment e000)    ; donde empieza _$1_array_offset en $3\n" $suma    #hexa
}

echo ";EMSDATA.ASM"
core "desc61_ems_en" "EMSDATA.ASM" "EMSDATA.BIN"
core "desc61_ems_es" "EMSDATA.ASM" "EMSDATA.BIN"
core "subcadena61_ems_en" "EMSDATA.ASM" "EMSDATA.BIN"
core "subcadena61_ems_es" "EMSDATA.ASM" "EMSDATA.BIN"
echo "_ems_size equ $(wc -c EMSDATA.BIN |cut -d" " -f1)d ; wc -c EMSDATA.BIN"
echo ";UMBDATA.ASM"
core "desc60_umb_en" "UMBDATA.ASM" "UMBDATA.BIN"
core "desc60_umb_es" "UMBDATA.ASM" "UMBDATA.BIN"
echo "_umb_size equ $(wc -c UMBDATA.BIN |cut -d" " -f1)d ; wc -c UMBDATA.BIN"

# $ ./hexpos.sh
#;EMSDATA.ASM
#_desc61_ems_en_array_offset equ 06269h ; (segment e000)    ; donde empieza _desc61_ems_en_array_offset en EMSDATA.BIN
#_desc61_ems_es_array_offset equ 0d6b2h ; (segment e000)    ; donde empieza _desc61_ems_es_array_offset en EMSDATA.BIN
#_subcadena61_ems_en_array_offset equ 0dd10h ; (segment e000)    ; donde empieza _subcadena61_ems_en_array_offset en EMSDATA.BIN
#_subcadena61_ems_es_array_offset equ 0e282h ; (segment e000)    ; donde empieza _subcadena61_ems_es_array_offset en EMSDATA.BIN
#_ems_size equ 58032d ; wc -c EMSDATA.BIN
#;UMBDATA.ASM
#_desc60_umb_en_array_offset equ 07215h ; (segment e000)    ; donde empieza _desc60_umb_en_array_offset en UMBDATA.BIN
#_desc60_umb_es_array_offset equ 0efd8h ; (segment e000)    ; donde empieza _desc60_umb_es_array_offset en UMBDATA.BIN
#_umb_size equ 62540d ; wc -c UMBDATA.BIN
