# This file is part of PALESTRA
#
# PALESTRA v0.1, abr-2021, GPL-2.0-or-later, vlan7 <https://www.vlan7.org>
# un TSR para traducir al castellano la aventura grafica/conversacional
# Les Manley in: Search for the King v2.0
#
# PALESTRA is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# PALESTRA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PALESTRA.  If not, see <https://www.gnu.org/licenses/>.
#
# why PALESTRA?
# $ grep les /usr/share/dict/spanish |grep tra
# palestra

#!/bin/bash

awk 'NR%2==0' Verbos.txt >verbo_es.txt   #pares
awk 'NR%2==1' Verbos.txt >verbo_en.txt   #impares
awk 'NR%2==0' Nombres.txt >nombre_es.txt   #pares
awk 'NR%2==1' Nombres.txt >nombre_en.txt   #impares
awk 'NR%2==0' Desc60_umb.txt >desc60_umb_es.txt   #pares
awk 'NR%2==1' Desc60_umb.txt >desc60_umb_en.txt   #impares
awk 'NR%2==0' Desc61_ems.txt >desc61_ems_es.txt   #pares
awk 'NR%2==1' Desc61_ems.txt >desc61_ems_en.txt   #impares
awk 'NR%2==0' Subcadena61_ems.txt >subcadena61_ems_es.txt   #pares
awk 'NR%2==1' Subcadena61_ems.txt >subcadena61_ems_en.txt   #impares

function core {
# $1: cadena
    IFS=$'\r\n' GLOBIGNORE='*' command eval  'XYZ=($(cat "$1"".txt"))'
    FN_OUTPUT="VAR_""$1"".txt"  # archivo de salida, listo para copiar en EMSDATA.ASM o UMBDATA.ASM
    LINEAS=$(wc -l "$1"".txt" |cut -d" " -f1)
    ((LINEAS--))
    for i in $( seq 0 $LINEAS )
    do
        echo "$1$i db \"${XYZ[$i]}\",0"
    done >"$FN_OUTPUT"

    echo "" >>"$FN_OUTPUT"

#    echo "$1_array dw " >>"$1""_var.txt"
    echo "$1_array dw " >>"$FN_OUTPUT"

    LINEAS=$(wc -l "$1"".txt" |cut -d" " -f1)
    ((LINEAS--))
    for i in $( seq 0 $LINEAS )
    do
        echo "$1""$i"","
    done |tr '\n' ' ' >>"$FN_OUTPUT"
    
    LINEAS=$(wc -l "$1"".txt" |cut -d" " -f1)
    echo "" >>"$FN_OUTPUT"
    echo "" >>"$FN_OUTPUT"
    echo "_$1_array_cx equ ""$LINEAS""d" >>"$FN_OUTPUT"     #ej: _desc61_ems_array_cx equ 615d
}

core "verbo_es"
core "verbo_en"
core "nombre_es"
core "nombre_en"
core "desc60_umb_es"
core "desc60_umb_en"
core "desc61_ems_es"
core "desc61_ems_en"
core "subcadena61_ems_es"
core "subcadena61_ems_en"

rm verbo_es.txt
rm verbo_en.txt
rm nombre_es.txt
rm nombre_en.txt
rm desc61_ems_es.txt
rm desc61_ems_en.txt
rm desc60_umb_es.txt
rm desc60_umb_en.txt
rm subcadena61_ems_es.txt
rm subcadena61_ems_en.txt
